String.prototype.replaceAll = function(search, replace){
	return this.split(search).join(replace);
}
String.prototype.trim = function() {
    return this.replace(/^\s+|\s+$/g,"");
}
String.prototype.ltrim = function(charlist){
	charlist = !charlist ? ' \s\xA0' : charlist.replace(/([\[\]\(\)\.\?\/\*\{\}\+\$\^\:])/g, '\$1');
	var re = new RegExp('^['+charlist+']+', 'g');
	return this.replace(re, '');
}
String.prototype.rtrim = function(charlist){
	charlist = !charlist ? ' \s\xA0' : charlist.replace(/([\[\]\(\)\.\?\/\*\{\}\+\$\^\:])/g, '\$1');
	var re = new RegExp('['+charlist+']+$', 'g');
	return this.replace(re, '');
}

String.prototype.translit = (function(filter_numeric_values){
    var L = {
'А':'A','а':'a','Б':'B','б':'b','В':'V','в':'v','Г':'G','г':'g',
'Д':'D','д':'d','Е':'E','е':'e','Ё':'Yo','ё':'yo','Ж':'Zh','ж':'zh',
'З':'Z','з':'z','И':'I','и':'i','Й':'Y','й':'y','К':'K','к':'k',
'Л':'L','л':'l','М':'M','м':'m','Н':'N','н':'n','О':'O','о':'o',
'П':'P','п':'p','Р':'R','р':'r','С':'S','с':'s','Т':'T','т':'t',
'У':'U','у':'u','Ф':'F','ф':'f','Х':'Kh','х':'h','Ц':'Ts','ц':'ts',
'Ч':'Ch','ч':'ch','Ш':'Sh','ш':'sh','Щ':'Sch','щ':'sch','Ъ':'"','ъ':'"',
'Ы':'Y','ы':'y','Ь':"'",'ь':"'",'Э':'E','э':'e','Ю':'Yu','ю':'yu',
'Я':'Ya','я':'ya'
        },
        r = '',
        k;
    for (k in L) r += k;
    r = new RegExp('[' + r + ']', 'g');
    k = function(a){
        return a in L ? L[a] : '';
    };
    
    return function(){
        return this.replace(r, k);
    };
})();

String.prototype.escapeHtml = function(){
	var map = {
		'&': '&amp;',
		'<': '&lt;',
		'>': '&gt;',
		'"': '&quot;',
		"'": '&#039;'
	};

	return this.replace(/[&<>"']/g, function(m) { return map[m]; });
}

function str_pad( input, pad_length, pad_string, pad_type ) {	// Pad a string to a certain length with another string
	input=input.toString();
	var half = '', pad_to_go;

	var str_pad_repeater = function(s, len){
			var collect = '', i;

			while(collect.length < len) collect += s;
			collect = collect.substr(0,len);

			return collect;
		};

	if (pad_type != 'STR_PAD_LEFT' && pad_type != 'STR_PAD_RIGHT' && pad_type != 'STR_PAD_BOTH') { pad_type = 'STR_PAD_RIGHT'; }
	if ((pad_to_go = pad_length - input.length) > 0) {
		if (pad_type == 'STR_PAD_LEFT') { input = str_pad_repeater(pad_string, pad_to_go) + input; }
		else if (pad_type == 'STR_PAD_RIGHT') { input = input + str_pad_repeater(pad_string, pad_to_go); }
		else if (pad_type == 'STR_PAD_BOTH') {
			half = str_pad_repeater(pad_string, Math.ceil(pad_to_go/2));
			input = half + input + half;
			input = input.substr(0, pad_length);
		}
	}

	return input;
}

ref=function(key, replaces){
	var tmp=key.split('::');
	res=app.refs[tmp[0]][tmp[1]];
	if(replaces){
		var keys=[], vals=[];
		$.each(replaces, function(i, item){
			keys[keys.length]='['+i+']';
			vals[vals.length]=item;
		})
		res=str_replace(keys, vals, res);
	}
	return res;
};

function urlT(call, file){
	return app.url+(file!='' ? '/'+file : '' )+'/'+call;
}

function urlA(call, file){
	return app.url+'/_action/'+file+'/'+call;
}

function urlU(call, file){
	return app.upload_url+'/_action/'+file+'/'+call;
}

function str_replace(search, replace, subject, count) {
	var i = 0, j = 0, temp = '', repl = '', sl = 0, fl = 0, f = [].concat(search), r = [].concat(replace), s = subject, ra = Object.prototype.toString.call(r) === '[object Array]', sa = Object.prototype.toString.call(s) === '[object Array]';
	s = [].concat(s);
	if (count) this.window[count] = 0;
	
	for (i = 0, sl = s.length; i < sl; i++) {
		if (s[i] === '') continue;
		for (j = 0, fl = f.length; j < fl; j++) {
			temp = s[i] + '';
			repl = ra ? (r[j] !== undefined ? r[j] : '') : r[0];
			s[i] = (temp).split(f[j]).join(repl);
			if (count && s[i] !== temp) this.window[count] += (temp.length - s[i].length) / f[j].length;
		}
	}
	return sa ? s : s[0];
}

function strtok (str, tokens) {
	this.php_js = this.php_js || {};
	
	if (tokens === undefined) {
		tokens = str;
		str = this.php_js.strtokleftOver;
	}
	
	if (str.length === 0) return false;
	if (tokens.indexOf(str.charAt(0)) !== -1) return this.strtok(str.substr(1), tokens);
	
	for (var i = 0; i < str.length; i++) {
		if (tokens.indexOf(str.charAt(i)) !== -1) break;
	}
	this.php_js.strtokleftOver = str.substr(i + 1);
	
	return str.substring(0, i);
}

function copyToClipboard(elem,  value) {
	var targetId = "_hiddenCopyText_";
	var isInput = elem.tagName === "INPUT" || elem.tagName === "TEXTAREA";
	var origSelectionStart, origSelectionEnd;
	if (isInput) {
		target = elem;
		origSelectionStart = elem.selectionStart;
		origSelectionEnd = elem.selectionEnd;
	} else {
		// must use a temporary form element for the selection and copy
		target = document.getElementById(targetId);
		if (!target) {
			var target = document.createElement("textarea");
			target.style.position = "absolute";
			target.style.left = "-9999px";
			target.style.top = "0";
			target.style.height = "0";
			target.id = targetId;
			document.body.appendChild(target);
		}
		target.textContent = value ? value : elem.textContent;
	}

	var currentFocus = document.activeElement;
	var x = window.scrollX, y = window.scrollY;
	target.focus();
	window.scrollTo(x, y);
	target.setSelectionRange(0, target.value.length);

	var succeed;
	try {
		succeed = document.execCommand("copy");
	} catch(e) {
		succeed = false;
	}

	if (currentFocus && typeof currentFocus.focus === "function") {
		currentFocus.focus();
	}

	if (isInput) {
		elem.setSelectionRange(origSelectionStart, origSelectionEnd);
	} else {
		target.textContent = "";
	}
	return succeed;
}

function onAnchorLinkTooltip($node){
	$node.tooltipster({
		animation: 'fade',
		delay: 200,
		side: 'top',
		theme: 'tooltipster-shadow',
		arrow: false,
		trigger: 'custom',
		triggerOpen: {click: true},
		contentAsHTML: true,
		content: '<a href="'+$node.attr('href')+'">Ссылка</a> скопирована в буфер обмена',
		triggerClose: {click: true, scroll: true},
		interactive: true,
		debug: false,
		functionAfter: function(instance){
			instance.destroy();
		}
	});
	$node.tooltipster('open');
}

Date.prototype.format = function(format) {
    var returnStr = '';
    var replace = Date.replaceChars;
    for (var i = 0; i < format.length; i++) {       var curChar = format.charAt(i);         if (i - 1 >= 0 && format.charAt(i - 1) == "\\") {
            returnStr += curChar;
        }
        else if (replace[curChar]) {
            returnStr += replace[curChar].call(this);
        } else if (curChar != "\\"){
            returnStr += curChar;
        }
    }
    return returnStr;
};

plural = function(a) {
	switch (app.lang.iso) {
		case 'ru':
			if ( a % 10 == 1 && a % 100 != 11 ) return 1
			else if ( a % 10 >= 2 && a % 10 <= 4 && ( a % 100 < 10 || a % 100 >= 20)) return 2
			else return 3;
		default:
			// method not implemented for this language
			return 1;
	}
};

declension = function(count, forms, return_number) {
	if (typeof(return_number) == "undefined") {
		return_number = true;
	}
	var n = Math.abs(count) % 100;
	var n1 = n % 10;
	if (n > 10 && n < 20) {
		return (return_number ? count + ' ' : '') + forms[2];
	}
	if (n1 > 1 && n1 < 5) {
		return (return_number ? count + ' ' : '') + forms[1];
	}
	if (n1 == 1) {
		return (return_number ? count + ' ' : '') + forms[0];
	}
	return (return_number ? count + ' ' : '') + forms[2];
}

function strip_tags(input, allowed) {
    allowed = (((allowed || "") + "").toLowerCase().match(/<[a-z][a-z0-9]*>/g) || []).join(''); // making sure the allowed arg is a string containing only tags in lowercase (<a><b><c>)
    var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi,
        commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;
    return input.replace(commentsAndPhpTags, '').replace(tags, function ($0, $1) {        return allowed.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : '';
    });
}


function number_format(number, decimals, dec_point, thousands_sep) {
	var i, j, kw, kd, km;

	if( isNaN(decimals = Math.abs(decimals)) ){
		decimals = 2;
	}
	if( dec_point == undefined ){
		dec_point = ",";
	}
	if( thousands_sep == undefined ){
		thousands_sep = ".";
	}

	i = parseInt(number = (+number || 0).toFixed(decimals)) + "";

	if( (j = i.length) > 3 ){
		j = j % 3;
	} else{
		j = 0;
	}

	km = (j ? i.substr(0, j) + thousands_sep : "");
	kw = i.substr(j).replace(/(\d{3})(?=\d)/g, "$1" + thousands_sep);
	kd = (decimals ? dec_point + Math.abs(number - i).toFixed(decimals).replace(/-/, 0).slice(2) : "");

	return km + kw + kd;
}


Date.replaceChars = {
    shortMonths: ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'],
    longMonths: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'],
    shortDays: ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'],
    longDays: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],

    // Day
    d: function() { return (this.getDate() < 10 ? '0' : '') + this.getDate(); },
    D: function() { return Date.replaceChars.shortDays[this.getDay()]; },
    j: function() { return this.getDate(); },
    l: function() { return Date.replaceChars.longDays[this.getDay()]; },
    N: function() { return this.getDay() + 1; },
    S: function() { return (this.getDate() % 10 == 1 && this.getDate() != 11 ? 'st' : (this.getDate() % 10 == 2 && this.getDate() != 12 ? 'nd' : (this.getDate() % 10 == 3 && this.getDate() != 13 ? 'rd' : 'th'))); },
    w: function() { return this.getDay(); },
    z: function() { var d = new Date(this.getFullYear(),0,1); return Math.ceil((this - d) / 86400000); }, // Fixed now
    // Week
    W: function() { var d = new Date(this.getFullYear(), 0, 1); return Math.ceil((((this - d) / 86400000) + d.getDay() + 1) / 7); }, // Fixed now
    // Month
    F: function() { return Date.replaceChars.longMonths[this.getMonth()]; },
    m: function() { return (this.getMonth() < 9 ? '0' : '') + (this.getMonth() + 1); },
    M: function() { return Date.replaceChars.shortMonths[this.getMonth()]; },
    n: function() { return this.getMonth() + 1; },
    t: function() { var d = new Date(); return new Date(d.getFullYear(), d.getMonth(), 0).getDate() }, // Fixed now, gets #days of date
    // Year
    L: function() { var year = this.getFullYear(); return (year % 400 == 0 || (year % 100 != 0 && year % 4 == 0)); },   // Fixed now
    o: function() { var d  = new Date(this.valueOf());  d.setDate(d.getDate() - ((this.getDay() + 6) % 7) + 3); return d.getFullYear();}, //Fixed now
    Y: function() { return this.getFullYear(); },
    y: function() { return ('' + this.getFullYear()).substr(2); },
    // Time
    a: function() { return this.getHours() < 12 ? 'am' : 'pm'; },
    A: function() { return this.getHours() < 12 ? 'AM' : 'PM'; },
    B: function() { return Math.floor((((this.getUTCHours() + 1) % 24) + this.getUTCMinutes() / 60 + this.getUTCSeconds() / 3600) * 1000 / 24); }, // Fixed now
    g: function() { return this.getHours() % 12 || 12; },
    G: function() { return this.getHours(); },
    h: function() { return ((this.getHours() % 12 || 12) < 10 ? '0' : '') + (this.getHours() % 12 || 12); },
    H: function() { return (this.getHours() < 10 ? '0' : '') + this.getHours(); },
    i: function() { return (this.getMinutes() < 10 ? '0' : '') + this.getMinutes(); },
    s: function() { return (this.getSeconds() < 10 ? '0' : '') + this.getSeconds(); },
    u: function() { var m = this.getMilliseconds(); return (m < 10 ? '00' : (m < 100 ?
'0' : '')) + m; },
    // Timezone
    e: function() { return "Not Yet Supported"; },
    I: function() { return "Not Yet Supported"; },
    O: function() { return (-this.getTimezoneOffset() < 0 ? '-' : '+') + (Math.abs(this.getTimezoneOffset() / 60) < 10 ? '0' : '') + (Math.abs(this.getTimezoneOffset() / 60)) + '00'; },
    P: function() { return (-this.getTimezoneOffset() < 0 ? '-' : '+') + (Math.abs(this.getTimezoneOffset() / 60) < 10 ? '0' : '') + (Math.abs(this.getTimezoneOffset() / 60)) + ':00'; }, // Fixed now
    T: function() { var m = this.getMonth(); this.setMonth(0); var result = this.toTimeString().replace(/^.+ \(?([^\)]+)\)?$/, '$1'); this.setMonth(m); return result;},
    Z: function() { return -this.getTimezoneOffset() * 60; },
    // Full Date/Time
    c: function() { return this.format("Y-m-d\\TH:i:sP"); }, // Fixed now
    r: function() { return this.toString(); },
    U: function() { return this.getTime() / 1000; }
};

function scrollbarWidth() {
	var inner = document.createElement('p');
	inner.style.width = "100%";
	inner.style.height = "200px";
	
	var outer = document.createElement('div');
	outer.style.position = "absolute";
	outer.style.top = "0px";
	outer.style.left = "0px";
	outer.style.visibility = "hidden";
	outer.style.width = "200px";
	outer.style.height = "150px";
	outer.style.overflow = "hidden";
	outer.appendChild (inner);
	
	document.body.appendChild (outer);
	var w1 = inner.offsetWidth;
	outer.style.overflow = 'scroll';
	var w2 = inner.offsetWidth;
	if (w1 == w2) w2 = outer.clientWidth;
	
	document.body.removeChild (outer);
	
	return (w1 - w2);
}

triggerClick=function(a, evt) {
	if(a.href.indexOf('javascript:')>=0) return true;

	if((evt && (evt.ctrlKey || evt.shiftKey || evt.metaKey)) || a.target.toLowerCase()=='_blank'){
		window.open(a.href);
	} else if($(a).hasClass('qajx')){
		app.redirect(getQajxUrl(a));
	} else {
		location.href=a.href;
	}

	return false;
}

triggerUrlRedirect=function(url, evt){
	if((evt && (evt.ctrlKey || evt.shiftKey || evt.metaKey))){
		window.open(url);
	} else {
		location.href=url;
	}

	return false;
}

parseLink=function(url){
	var prot='';
	if(url.indexOf('@')>0) prot='mailto:';
	else if(!/(http|ftp|https:\/\/)/.test(url)) prot='http://';
	
	return prot+url;
}

function printIframe(frameName){
	window[frameName].focus();
	if(navigator.appVersion.indexOf("MSIE 7") != -1) {
		window[frameName].document.execCommand('print', false, null);
	} else {
		window[frameName].print();
	}
}

function refreshKcpatcha(id){
	document.getElementById(id).src=document.getElementById(id).src.replace(/rnd=.+/, 'rnd='+Math.random());
}

function prDefault(evt){
	evt=(evt)?evt:window.event;
	if(evt){
		if(evt.stopPropagation){
			evt.stopPropagation();
			evt.preventDefault();
		} else if(evt) {
			evt.cancelBubble=true;
		}
	}
}

object_to_source = function(obj, check) {
    var con = obj.constructor;
    if(con == String) {
        return '"' + obj + '"';
    } else if(con == Number || con == Boolean) {
        return obj;
    } else if(con == Array) {
        var res = '[';
        for(var i=0,len=obj.length;i<len;i++) {
            if(i == len-1)
                res += object_to_source(obj[i]);
            else
                res += object_to_source(obj[i]) + ', ';
        }
	res += ']';
        return res;
    } else if(con == RegExp) {
        return obj;
    } else if(con == Object) {
        var res = '{';
        var i=0;
        for(var j in obj) {
            if(j != 'object_to_source') {
                if(i == 0) {
                    res += j + ':' + object_to_source(obj[j], 1);
                } else {
                    res += ', ' + j + ':' + object_to_source(obj[j], 1);
                }
                i++;
            }
        }
        res += '}';
        if(check) {
            return res;
        } else {
            return '(' + res + ')';
        }
    }
}

function serialize( mixed_value ) {
    var _getType = function( inp ) {
        var type = typeof inp, match;
        var key;
        if (type == 'object' && !inp) {
            return 'null';
        }
        if (type == "object") {
            if (!inp.constructor) {
                return 'object';
            }
            var cons = inp.constructor.toString();
            if (match = cons.match(/(\w+)\(/)) {
                cons = match[1].toLowerCase();
            }
            var types = ["boolean", "number", "string", "array"];
            for (key in types) {
                if (cons == types[key]) {
                    type = types[key];
                    break;
                }
            }
        }
        return type;
    };
    var type = _getType(mixed_value);
    var val, ktype = '';
    
    switch (type) {
        case "function": 
            val = ""; 
            break;
        case "undefined":
            val = "N";
            break;
        case "boolean":
            val = "b:" + (mixed_value ? "1" : "0");
            break;
        case "number":
            val = (Math.round(mixed_value) == mixed_value ? "i" : "d") + ":" + mixed_value;
            break;
        case "string":
            val = "s:" + mixed_value.length + ":\"" + mixed_value + "\"";
            break;
        case "array":
        case "object":
            val = "a";
            var count = 0;
            var vals = "";
            var okey;
            var key;
            for (key in mixed_value) {
                ktype = _getType(mixed_value[key]);
                if (ktype == "function") { 
                    continue; 
                }
                
                okey = (key.match(/^[0-9]+$/) ? parseInt(key) : key);
                vals += serialize(okey) +
                        serialize(mixed_value[key]);
                count++;
            }
            val += ":" + count + ":{" + vals + "}";
            break;
    }
    if (type != "object" && type != "array") val += ";";
    return val;
}

//Cookie functions
function setCookie(c_name,value,expiredays){
	var exdate=new Date()
	exdate.setDate(exdate.getDate()+expiredays)
	document.cookie=c_name+ "=" +escape(value)+((expiredays==null) ? "" : ";expires="+exdate.toGMTString())+'; path=/';
}

function getCookie(c_name){
	if (document.cookie.length>0)	{
		c_start=document.cookie.indexOf(c_name + "=")
		if (c_start!=-1){
			c_start=c_start + c_name.length+1 
			c_end=document.cookie.indexOf(";",c_start)
			if (c_end==-1) c_end=document.cookie.length
			return unescape(document.cookie.substring(c_start,c_end))
		} 
	}
	return ""
}

//FCKEDitor Update instances on ajax request
function preSubmitAJAX(){
	if(FCKeditorAPI && FCKeditorAPI.__Instances){
		$.each(FCKeditorAPI.__Instances, function(gid, oEditor){
			oEditor.UpdateLinkedField();
		});
    }
	return true;
}

jQuery.input_default=function(selector){
	$(selector).focus(function(){
		if(this.value.trim()==$(this).attr('default')){
			$(this).removeClass('input_inactive');
			this.value='';
		}
	}).blur(function(){
		if(this.value.trim()==''){
			$(this).addClass('input_inactive');
			this.value=$(this).attr('default');
		}
	});
}

function getCaret(el) { 
	if (el.selectionStart) { 
		return el.selectionStart; 
	} else if (document.selection) { 
		el.focus(); 

		var r = document.selection.createRange(); 
		if (r == null) { 
			return 0; 
		} 

		var re = el.createTextRange(), 
		rc = re.duplicate(); 
		re.moveToBookmark(r.getBookmark()); 
		rc.setEndPoint('EndToStart', re); 

		return rc.text.length; 
	}  
	return 0; 
}

function setSelRange(inputEl, selStart, selEnd) {
	if($(inputEl).attr('contenteditable')){
		var range,selection;
	    if(document.createRange)//Firefox, Chrome, Opera, Safari, IE 9+
	    {
	        range = document.createRange();//Create a range (a range is a like the selection but invisible)
	        range.selectNodeContents(inputEl);//Select the entire contents of the element with the range
	        range.collapse(true);//collapse the range to the end point. false means collapse to end rather than the start
	        selection = window.getSelection();//get the selection object (allows you to change selection)
	        selection.removeAllRanges();//remove any selections already made
	        selection.addRange(range);//make the range you have just created the visible selection
	    }
	    else if(document.selection)//IE 8 and lower
	    { 
	        range = document.body.createTextRange();//Create a range (a range is a like the selection but invisible)
	        range.moveToElementText(inputEl);//Select the entire contents of the element with the range
	        range.collapse(true);//collapse the range to the end point. false means collapse to end rather than the start
	        range.select();//Select the range (make it the visible selection
	    }
	} else {
		if (inputEl.setSelectionRange) { 
			inputEl.focus(); 
			inputEl.setSelectionRange(selStart, selEnd); 
		} else if (inputEl.createTextRange) { 
			var range = inputEl.createTextRange(); 
			range.collapse(true); 
			range.moveEnd('character', selEnd); 
			range.moveStart('character', selStart); 
			range.select(); 
		} 
	} 
}

function placeCaretAtEnd(el) {
    if (!el){
        return;
    }
    el.focus();
    if (typeof window.getSelection != "undefined"
        && typeof document.createRange != "undefined") {
        var range = document.createRange();
        range.selectNodeContents(el);
        range.collapse(false);
        var sel = window.getSelection();
        sel.removeAllRanges();
        sel.addRange(range);
    } else if (typeof document.body.createTextRange != "undefined") {
        var textRange = document.body.createTextRange();
        textRange.moveToElementText(el);
        textRange.collapse(false);
        textRange.select();
    }
}

function insertAtCursor(myField, myValue){
	var pos=getCaret(myField)+myValue.length;
	var scroll=myField.scrollTop;
	
	if (document.selection) {
		//IE support
		myField.focus();
		sel = document.selection.createRange();
		sel.text = myValue;
	} else if (myField.selectionStart || myField.selectionStart == '0') {
		//MOZILLA/NETSCAPE support
		var startPos = myField.selectionStart;
		var endPos = myField.selectionEnd;
		myField.value = myField.value.substring(0, startPos)+myValue+myField.value.substring(endPos, myField.value.length);
	} else {
		myField.value += myValue;
	}
	setSelRange(myField, pos, pos);
	
	myField.focus();
	myField.scrollTop=scroll;
}

function insertNodeAtCaret(node, clean) {
    var sel = rangy.getSelection();
    if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        if(clean) range.deleteContents();
        range.collapse(false);
        range.insertNode(node);
        range.collapseAfter(node);
        sel.setSingleRange(range);
    }
}

function getSelectionText(){
    var selectedText = '';
    var sel = rangy.getSelection();
    if (sel.rangeCount) {
        var range = sel.getRangeAt(0);
        selectedText = range.toString();
    }else if (window.getSelection) {  // all browsers, except IE before version 9
        var range = window.getSelection ();
        selectedText = range.toString ();
    }else if (document.selection.createRange) { // Internet Explorer
        var range = document.selection.createRange ();
        selectedText = range.text;
    }

    return selectedText;
}

function getSelectionContainer(){
    if (document.selection){  // IE
        return document.selection.createRange().parentElement();
    }

    var select = window.getSelection();
    if (select.rangeCount > 0) {
        return select.getRangeAt(0).startContainer.parentNode;
    }

    return false;
};

function getCharacterOffsetWithin(range, node) {
    var treeWalker = document.createTreeWalker(
        node,
        NodeFilter.SHOW_TEXT,
        function(node) {
            var nodeRange = document.createRange();
            nodeRange.selectNode(node);
            return nodeRange.compareBoundaryPoints(Range.END_TO_END, range) < 1 ?
                NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_REJECT;
        },
        false
    );

    var charCount = 0;
    while (treeWalker.nextNode()) {
        charCount += treeWalker.currentNode.length;
    }
    if (range.startContainer.nodeType == 3) {
        charCount += range.startOffset;
    }
    return charCount;
}

function getSelectionHtml(){
    var selectedHtml = '';

    if (window.getSelection) {  // all browsers, except IE before version 9
        var sel = window.getSelection ();
        if (sel.getRangeAt){
            var range = sel.getRangeAt(0);
        }else{
            var range = document.createRange();
            range.setStart(sel.anchorNode, sel.anchorOffset);
            range.setEnd(sel.focusNode, sel.focusOffset);
        }

        var div = document.createElement('div');
        div.appendChild(range.cloneContents());
        selectedHtml = div.innerHTML;

    }else if (document.selection && document.selection.createRange) { // Internet Explorer
        var range = document.selection.createRange ();
        selectedHtml = range.htmlText;
    }

    return selectedHtml;
}

function replaceSelectionHtml(replacementHtml) {
    var sel, range;
    if (window.getSelection) {
        sel = window.getSelection();
        if (sel.rangeCount) {
            range = sel.getRangeAt(0);
            range.deleteContents();
            var node = document.createElement('span');
            node.innerHTML = replacementHtml;
            range.insertNode(node);
        }
    } else if (document.selection && document.selection.createRange) {
        range = document.selection.createRange();
        range.htmlText = replacementHtml;
    }
}


function replaceSelectedText(obj, cbFunc){
	if($(obj).attr('contenteditable')){
		var sel = rangy.getSelection();
		if (sel.rangeCount) {
			var range = sel.getRangeAt(0);
			selectedText = range.toString();
			if(typeof(cbFunc)=='function') eval("selectedText=cbFunc(selectedText);");
				else selectedText=cbFunc.replace('[s]', selectedText);
			var node=$(selectedText).get(0);
			range.deleteContents();
			range.collapse(false);
			range.insertNode(node);
			range.collapseAfter(node);
			sel.setSingleRange(range);
		}
	} else {
		obj.focus();
		if (document.selection){
			var s = document.selection.createRange();
			if(typeof(cbFunc)=='function') eval("s.text=cbFunc(s.text);");
				else s.text=cbFunc.replace('[s]', s.text);
			s.select();
			return true;
		} else if (typeof(obj.selectionStart)=="number"){
			var start = obj.selectionStart;
			var end = obj.selectionEnd;
			var sel_text=obj.value.substr(start,end-start);
			var rs='';
			if(typeof(cbFunc)=='function') eval("rs = "+cbFunc+"(sel_text);");
				else rs=cbFunc.replace('[s]', sel_text);
			obj.value = obj.value.substr(0,start)+rs+obj.value.substr(end);
			obj.setSelectionRange(start+rs.length, start+rs.length);
			
			return true;
		}

		return false;
	}
}

jumpAndStop=function(evt){
	evt.stopPropagation();
	
	if(evt.ctrlKey){
		window.open(this.href);
		return false;
	} else {
		return true;
	}
}

array_has=function(a, v,i){
	for (var j=0;j<a.length;j++){
		if (a[j]==v) return (!i ? true : j);
	}
	return false;
}

app.personalAlertMng = {
	show: function(){
		var _this = this;
		app.loadStatic(['jquery/postmessage.js'], true, function(){
			_this.drawIntegrationIframe();
		});
	},
	drawIntegrationIframe: function(){
		var _this = this;
		var $iframe = jQuery('<iframe>').attr({
			src: app.url + '/personal_alert/integrate_window',
			name: 'personal_alert_iframe',
			id: 'personal_alert_iframe',
			scrolling: 'no',
			frameborder: '0',
			allowTransparency: "true",
			marginwidth: "0",
			marginheight: "0",
			vspace: "0",
			hspace: "0"
		});
		$('body').append($iframe.hide());
		$iframe.bind('load', function(){
			_this.bindIframeActions(this);
		});
	},
	bindIframeActions: function(frame){
		var _this = this;
		pm({
			target: window.frames[frame.id],
			type:   "register",
			data:   {
				id:frame.id,
				page_url: app._page_url,
				page_ref: app._page_ref
			},
			url: frame.contentWindow.location
		});

		pm.bind('correct_data', function(data) {
			var iframe = document.getElementById(data.id);
			if (iframe == null) return;
			if (data.height){
				iframe.style.height=data.height+'px';
			}
		});

		pm.bind('show_window', function(data) {
			$('html').css('overflow', 'hidden');
			var $iframe = $('#'+data.id);
			$iframe.width($(window).width());
			$iframe.height($(window).height());
			$iframe.css({
				position: 'fixed',
				left: 0,
				top:0,
				width: '100%',
				height: '100%',
				zIndex: 10000000
			});
			$iframe.show();
		});

		pm.bind('process_resp', function(data) {
			var resp = data.resp;
			if (resp.success){
				if (resp.action=='redirect'){
					location.href = resp.url;
					return false;
				}
			}

			$('html').css('overflow', 'auto');
			var $iframe = $('#'+data.id);
			$iframe.remove();
		});

		pm.bind('goto_link', function(data) {
			var link = data.link;
			window.open(link);
		});

		pm.bind('close_window', function(data) {
			$('html').css('overflow', 'auto');
			var $iframe = $('#'+data.id);
			$iframe.remove();
		});
	}
}


app.loadStatic=function(static_files, once, callback, tagAppend){
	if (typeof(once) == "undefined") once = true;
	if (typeof(tagAppend) == "undefined") tagAppend = true;

	var loaded=0;
	var cmp=function(){
		loaded++;
		if(loaded==static_files.length && typeof(callback)!='undefined'){
			callback();
		}
	}
	
	if(static_files.length>0){
		for (var i=0; i<static_files.length; i++){
            var url = static_files[i].indexOf('http')==-1 ? app.frontend+'/'+static_files[i] : static_files[i];
			if (app._static_stamp){
				url = static_files[i].indexOf('?')==-1 ? url+'?'+app._static_stamp : url;
			}
			if (once){
				Loader.includeOnce(url, false, cmp, tagAppend);
			}else{
				Loader.include(url, false, cmp, tagAppend);
			}
		}
	} else {
		if(typeof(callback)!='undefined') callback();
	}
}

app.load=function(query, fnc, data_params){
	if(window['call_process']) return false;
	query=query.ltrim('/').trim();
	if(query=='') query='index';
	
	window['call_process']=1;

	if(fnc){
		fnc(0);
		window['call_on_complete']=fnc;
	}

	app.addMainProgressLayer();
	window['call_ajax_obj'] = $.getJSON(app.url+'/'+query, {qajx:1, scr_dims:[$(window).width(), $(window).height()]}, function(resp){
		var delayDraw=false;

		if(resp.blocks){
			//Invalidate old data

			var invalidate='';

			$.each(app.blocks, function(bid, item){
				if(!array_has(resp.blocks, bid)) invalidate=true;
				if(invalidate) delete(app.blocks[bid]);
			})
			
			//Load data
			$.each(resp.blocks, function(i, item){
				if(!app.blocks[item] || !app.blocks[item].init){
					delayDraw=true;
					app.blocks[item]={init:0, loaded:0, html:''};
					$.getJSON(app.url+'/'+item, {qajx:1, qajx_block:1}, function(bresp){
						app.draw(resp, item, bresp, data_params);
					})
				}
			})
		}

		if(!delayDraw){
			app.draw(resp, false, false, data_params);
			if(window['call_on_complete']){
				window['call_on_complete'](1);
				window['call_on_complete']=false;
			}
		}
	});
}

app.blocks_display=function(status, blocks, data_params){
	var $parent=$('#'+blocks[0][0]);
	
	if(!window['appDrawProgress']){
		window['appDrawProgress']=2;
	}
	
	if(status==1 && window['appDrawProgress']==2){
		var initHeight=$parent.height();
		
		if (!data_params || !data_params['qajx_no_scroll']){
//			$('html,body').animate({scrollTop: 0}, 100);
			window.scrollTo(0, 0);
		}

		$.each(blocks, function(i, block){
			$('#'+block[0]).html(block[1]);
		});
		
		$parent.css({display:'block', visibility:'visible'});
		$(document).trigger('pageReady');

        app._page_ref = app._page_url;
        app._page_url = location.href;

        $('form').each(function(){
            if ($(this).find('[name="_page_url"]').size()==0){
                $(this).append($('<input>').attr({type: 'hidden', name: '_page_url', value: app._page_url}));
                $(this).append($('<input>').attr({type: 'hidden', name: '_page_ref', value: app._page_ref}));
            }
        });

		if (app.id=='user'){
			pageViewMng.recordHit();
			app.userAlertMng.check();

			if (app.responsive_mode){
				if ($('body').hasClass('general_header_panel')){
					$('body').find('#header').css({
						top: $('.general_header.float').outerHeight()+'px'
					});
				}
			}
		}

		app.loadAjxBlocks();

		window['appDrawProgress']=0;
		window['call_process']=0;

		if ($('.recommended_items_block').size()>0 && $('.gr_posts_list.items_list').size()==0){
			$('.recommended_items_block').remove();
		}

		if (typeof(countersCall)=="function"){
			countersCall(getAppUrl(location), document.title);
		}
	} else if(status==1){
		var recall=arguments;
		setTimeout(function(){
			recall.callee.call(this, recall[0], recall[1]);
		}, 300);
	}
}

$(document).ready(function(){
	$(document).trigger('pageReady');
});

app.addProgressLayer=function(obj, indicator){
	if (typeof(indicator) == "undefined"){
		indicator = false;
	}

	if (indicator){
		var addIndicator = function(container){
			var $indicator = $('<div></div>').attr({'class': 'progressLayerIndicator'});
			if (app.responsive_mode){
				$indicator.spin({radius: 8, width: 2, lines: 17, length: 6});
			}else{
				$indicator.spin({radius: 13, width: 4, lines: 19, length: 8});
			}


			container.append($indicator);

			var left = parseInt(/*$(window).scrollLeft() + */$(window).width() - $indicator.width()-30, 10);
			var top = parseInt(/*$(window).scrollTop() + */20, 10);

			$indicator.css({left: left, top: top});
		}
		addIndicator(obj);
	}
}

app.progressTimeoutHandler = null;

app.addMainProgressLayer = function(){
	var TIMEOUT_VALUE = 800;
	app.progressTimeoutHandler = window.setTimeout(function(){
		app.addProgressLayer($('body'), true);
	}, TIMEOUT_VALUE);
}

app.removeProgressLayer=function(obj){
	window.clearTimeout(app.progressTimeoutHandler);
	obj.children('.progressLayer, .progressLayerIndicator').remove();
}

app.switchButtonIdle = function(obj,mode,color,position, auto_width){
	if (obj.find('b>em>i').size()>0){
		obj = obj.find('b>em>i');
	}
    var width = obj.outerWidth();
    var height = obj.outerHeight();
    var box_sizing = obj.css('box-sizing');

    if (mode==true){
        obj.width(width);
        obj.height(height);
		obj.data('initial_text_align', obj.css('text-align'));
        obj.css({'box-sizing' : 'border-box', 'text-align': 'center', 'padding-left': 0, 'padding-right': 0});
        obj.data('initial_text', obj.text()).html('&nbsp;');
        obj.data('initial_height', obj.height());
        obj.data('initial_box_sizing', box_sizing);
    }else{
        obj.text(obj.data('initial_text'));
        obj.css({'box-sizing' : obj.data('initial_box_sizing')});
		obj.css({'text-align' : obj.data('initial_text_align')});
        if (obj.data('initial_box_sizing')=='content-box'){
            obj.height(obj.data('initial_height'));
        }
		if (auto_width){
			obj.css({width : 'auto'});
		}
    }

    var options = {radius: 4, lines:11, width: 2, color: color};
    if (height>30){
        options = {radius: 6, lines:13, width: 3, color: color};
    }

    if (position){
        options['left'] = position.left;
        options['top'] = position.top;
    }

    app.switchProgress(obj, mode, options);
}

app.switchIdle = function(obj,mode, color){
	if (obj.size()==0){
		return;
	}
	if (typeof(color)=="undefined"){
		color = (obj.parents('#iviewer').size()>0 ? '#FFFFFF' : '#000000');
	}
	app.switchProgress(obj, mode, {radius: 4, lines:11, width: 2, color: color});
}
app.switchProgress = function(obj,mode,options){
	if (mode){
		obj.addClass('idle').spin(options);
	}else if(obj.hasClass('idle')){
		obj.spin('remove').removeClass('idle');
	}
}


app.showTooltip = function($object, text, type, options){
    var $tooltip = $('<div></div>').addClass('tiny_tooltip '+(type ? type : '')+(options['class_name'] ? ' '+options['class_name'] : '')).html(text).hide();
    if (type=='prompt'){
        $tooltip.append('<div class="prompt_links"><a class="link2 prompt_link yes_link">Да</a><a class="link2 prompt_link cancel_link">Нет</a></div>');
        $tooltip.find('a.prompt_link.cancel_link').on('click', function(){
            app.hideTooltips();
        });
        $tooltip.find('a.prompt_link.yes_link').on('click', function(){
            app.hideTooltips();
            if (options && options['on_yes']){
                options['on_yes']();
            }
        });
    }
    $object.after($tooltip);
    if (typeof(options['autopositioning'])!="undefined" && options['autopositioning']){
        var left = $object.position().left+$object.width()/2-$tooltip.width()/2;
        $tooltip.css({marginLeft: 0, left: left});
    }
    $tooltip.fadeIn(function(){
        $('body').bind('click.tooltip', function(event){
            if ($(event.target).closest($tooltip).size()==0 && !$(event.target).is($tooltip)){
                app.hideTooltips();
            }
        });
    });
    if (type=='error'){
        $tooltip.on('click', function(){
            app.hideTooltips();
        });
    }
}

app.hideTooltips = function(){
    $('.tiny_tooltip').fadeOut(function(){$(this).remove();});
    $('body').unbind('click.tooltip');
}

app.objSize = function(obj){
    var length = 0;
    for (var i in obj){
        length++;
    }
    return length;
}


app.draw=function(resp, block, bresp, data_params){
	var blocks=[];
	var staticFiles=[];
	var staticBlock=[];
	var binit=true;

	app.removeProgressLayer($('body'));
	if(block){
		app.blocks[block]={
			init:0,
			loaded:1,
			html:bresp
		};

		$.each(resp.blocks, function(i, item){
			if(binit && app.blocks[item] && app.blocks[item].loaded){
				if(!app.blocks[item].init){
					$.each(app.blocks[item].html, function(pid, bhtml){
						//Collect html
						if(!array_has(['blocks', 'static_files', 'static_block'], pid)){
							blocks[blocks.length]=[pid, bhtml, item];
							app.blocks_display(0, blocks);
						}
						
						//Collect block static to load
						if(pid=='static_files' && bhtml.length>0){
							for(var i=0; i<bhtml.length; i++) staticFiles[staticFiles.length]=bhtml[i];
						} else if(pid=='static_block' && bhtml.length>0) {
							for(var i=0; i<bhtml.length; i++) staticBlock[staticBlock.length]=bhtml[i];
						}
					});
				}
			} else {
				binit=false;
				return false;
			}
		});
	}

	if(!binit) return false;

	$.each(resp, function(pid, bhtml){
		if(!array_has(['blocks', 'static_files', 'static_block'], pid)){
			blocks[blocks.length]=[pid, bhtml];
		}
	});
	
	//Collect main page static to load
	if(typeof(resp.static_files)!="undefined" && resp.static_files!=null && resp.static_files.length>0){
		for(var i=0; i<resp.static_files.length; i++) staticFiles[staticFiles.length]=resp.static_files[i];
	} else if(typeof(resp.static_block)!="undefined" && resp.static_block!=null && resp.static_block.length>0) {
		for(var i=0; i<resp.static_block.length; i++) staticBlock[staticBlock.length]=resp.static_block[i];
	}
	
	var draw_func=function(){
		app.blocks_display(1, blocks, data_params);

		$.each(resp.blocks, function(i, item){
			if(!app.blocks[item].init){
				$.each(app.blocks[item].html, function(pid, bhtml){
					if(pid!='blocks'){
						app.blocks[item].init=1;
						app.blocks[item].html='';
					}
				});
			}
		});
	}
	
	app.loadStatic(staticFiles, true, function(){
		app.loadStatic(staticBlock, true, draw_func, 0);
	}, 1);
}

app.reload=function(){
	for (var i=0; i<arguments.length;i++){
		app.blocks[arguments[i]].init=0;
	}
	
	var req=getQajxUrl(window.location);
	app.load( req!='' ? req : (app.guest==1?'login':'index') );
}

if(history.pushState){
	app.redirect=function(query, fnc, force_load, data_params){
		if(window['call_process']) return false;
		var new_loc=query.ltrim('/');

		if(fnc) fnc(0);
		window['call_on_complete']=fnc;

		initialURL=app.url+'/'+query;
		popped = true;

		app.load(query, false, data_params);
		
		if(!data_params || !data_params['qajx_skip_redirect']){
			history.pushState(query, '', app.url+'/'+query);
		}
	}

	var popped = false, initialURL = location.href;
	$(window).bind('popstate', function(e){
		onBeforeUnload=false;
		
		var initialPop = !popped && (location.href == initialURL || getAppUrl(location)==getQueryUrl(initialURL));
		popped = true;
		if (initialPop) return;

		app.load(getAppUrl(location));
	})
	
	app.set_url=function(query){
		var new_loc=query.ltrim('/');
		if(new_loc.indexOf(app.url)<0) new_loc=app.url+'/'+new_loc;
		history.pushState(false, '', new_loc);
		initialURL=app.url+'/'+new_loc;
	}

    app.replace_url = function(query){
        var new_loc=query.ltrim('/');
        if(new_loc.indexOf(app.url)<0) new_loc=app.url+'/'+new_loc;
			history.replaceState(false, '', new_loc);
    }
} else {
	app.redirect=function(query, fnc, force_load, data_params){
		if(typeof(force_load)=='undefined') force_load=true;
		
		var new_loc='#'+query.ltrim('/');
		if(window.location.hash!=new_loc){
			if(fnc) fnc(0);
			window['call_on_complete']=fnc;
			
			if(!data_params || !data_params['qajx_skip_redirect']){
				location.href=new_loc;
			}
		} else if(force_load) {
			if(fnc) fnc(0);
			window['call_on_complete']=fnc;
			app.load(query, false, data_params);
		}
	}
	
	app.set_url=function(query){
		var check=query.split('#');
		new_loc=(check.length>=2)?check[1]:query;
		if(new_loc.indexOf(app.url)>=0) new_loc=new_loc.substr(app.url.length);
		new_loc=new_loc.ltrim('\/#');

		window['noJumpOnHashChange']=1;
		location.href='#'+new_loc;
	}

    app.replace_url = function(query){
        app.set_url(query);
    }
}

app.block_register=function(bid){
	 if(app.blocks) app.blocks[bid]={html:'', init:1, loaded:1};
}

app.block_delete=function(bid, del_childs){
	if(typeof(del_childs)=='undefined') del_childs=true;
	if(del_childs){
		var rfinded=false;
		for (i in app.blocks){
			if(!rfinded && i==bid) rfinded=true;
			if(rfinded) delete(app.blocks[i]);
		}
	} else {
		if(app.blocks[bid]) delete(app.blocks[bid]);
	}
}

app.block_update_fnc=function(bid, options){
	options=$.extend({
		url:'',
		instantCall:false,
		dataType:'json',
		isPost:false,
		data:{},
		interval:5000,
		onSuccess:false,
		onComplete:false,
		onError:false,
		onLeave:false,
		reLaunchOnError:true,
		xhr:false
	}, options);
	
	var uniqId=Math.random();

	if(!app.blocks[bid]) return false;

	app.blocks[bid].uniqId=uniqId;
		
	if(options.url.trim()=='') return false;

	options.wnStatus=($('body').hasClass('wn_blurred') || document['hidden']) ? 0 : 1;
	
	$(window).unbind('blur.'+bid).bind('blur.'+bid, function(){
		options.wnStatus=0;
	}).unbind('focus.'+bid).bind('focus.'+bid, function(){
		options.wnStatus=1;
		block_upd_fnc();
	})
	
	var checkBlockExists=function(){
		if(!app.blocks[bid] || app.blocks[bid].uniqId!=uniqId){
			//Block not exists no more
			if(options.onLeave) options.onLeave.call(options);
			return false;
		}
		
		return true;
	}

	var block_upd_fnc=function(){
		if(options.xhr) options.xhr.abort();
		if(options.wnStatus==0 || !checkBlockExists()) return false;
		
		var req={
			url:options.url,
			method:(options.isPost ? 'POST' : 'GET'),
			data:options.data,
			async:true,
			dataType:options.dataType,
			success:function(resp){
				if(!checkBlockExists()) return false;
				
				if(resp.recall_required){
					setTimeout(block_upd_fnc, resp.recall_required);
				} else {
					if(options.onSuccess) options.onSuccess.call(options, resp, bid);
					
					setTimeout(block_upd_fnc, options.interval);
				}
			},
			complete:function(resp){
				if(options.onComplete) options.onComplete.call(options, resp, bid);
			},
			error:function(textStatus, errorThrown){
				if(!checkBlockExists()) return false;
				
				if(options.onError) options.onError.call(options, textStatus, errorThrown);
				if(options.reLaunchOnError) setTimeout(block_upd_fnc, options.interval);
			}
		};
		
		options.xhr=$.ajax(req);
	}
	
	if(options.instantCall){
		block_upd_fnc();
	} else {
		setTimeout(block_upd_fnc, options.interval);
	}
	
	return true;
}

app.parseQuery=function(query){
	var params={};
	var tmp=query.split('?');
	if(tmp[1]){
		tmp=tmp[1].split('&');
		for(var i=0; i<tmp.length; i++){
			sub=tmp[i].split('=');
			params[sub[0]]=sub[1];
		}
	}
	
	return params;
}

app.loadAjxBlocks = function(){
	$('.ajax_block_loading:not(.active)').each(function(){
		var $node = $(this);
		$node.addClass('active').addClass('idle_indicator');
		$.ajGet($node.data('url'), {ajx: 1}, function(resp){
			$node.html(resp).removeClass('ajax_block_loading').removeClass('active').removeClass('idle_indicator');
			iconAsyncLoader.loadIcons();
		}, false);
	});
}

app.initGeneralFloatPanel = function(mode){
	var correctPosition = function(){
		$('body').addClass('general_header_panel');
		if (app.responsive_mode){
			$('body').find('#header').css({
				top: $('.general_header.float').outerHeight()+'px'
			});
		}
	}

	var floatPanel = function(){

		var $float_header = $('.general_header.float');
		if ($float_header.size()==0){
			var $base_panel = $('.general_header');
			$float_header = $base_panel.clone();
			$float_header.addClass('float');
			$('body').append($float_header);

			$float_header.css({
				position: 'fixed',
				top: 0,
				left: 0,
				width: '100%',
				zIndex: app.responsive_mode ? 100000 : 1000000
			});

			if (mode!='start'){
				$float_header.hide().fadeIn();
			}

			$base_panel.css({opacity: 0});
		}
	};

	floatPanel();
	correctPosition();

}

app.bindCommonActions = function(settings){
	app.loadAjxBlocks();
	$('[rel="admin_pay"]').live('click', function(){
		var $obj = $(this);
		var user_id = $(this).data('user_id');
		if (!user_id){
			return false;
		}
		app.addProgressLayer($('body'), true);

		$.ajGetJSON(settings.admin_pay_url+'/'+user_id, {}, function(resp){
			app.removeProgressLayer($('body'));
			if (!resp.success){
				$.popup_alert(resp.error);
			} else {
				$.popup_alert({text:resp.html, modal: true, auto_hide: false, close_button: false, load_fnc : function(){
					$('.popup').find('input[type="text"]:enabled').focus();

					$.ajForm('admin_pay', function(res, form){
						var $successForm = $('.popup').find('.adminPaySuccess');
						$successForm.find('.value').text(res.data.sum_of_add);
						$.popup_hide();
						$.popup_alert({text: $successForm.html(), auto_hide: false, modal: true, custom_class:'adminPaySuccess'});
						$obj.siblings('input[name="balance"]').val(res.data.balance);
						$obj.siblings('span.value').html(res.data.format_balance);
					}, false);
				}});
			}
		}, false);
		return false;
	});

	$('[rel="usubscribe"]').die('click').live('click', function(){
		var $btn = $(this);
		var params = {
			mode: $btn.data('mode'),
			page: $btn.data('page'),
			callback_fnc: $btn.data('callback_fnc')
		}
		if ($btn.hasClass('xhr_process')){
			return false;
		}

		$btn.addClass('xhr_process');
		app.switchIdle($btn, true);
		$.ajPost(settings.subscribe_url+'/'+$btn.data('uid'), params, function(resp){
			$btn.removeClass('xhr_process');
			if (!resp.success){
				app.switchIdle($btn, false);
				$.popup_alert({
					text : resp.errors[0],
					auto_hide : false,
					modal: true
				});
			} else {
				var $new = $(resp.html).hide();
				$btn.after($new);
				$btn.fadeOut(200, function(){
					$new.fadeIn(200);
                    $new.css('display', 'inline-block');
				});

				if ($btn.data('callback_fnc') && window[$btn.data('callback_fnc')]){
					window[$btn.data('callback_fnc')]($btn.data('uid'), params.mode);
				}
				var $counter = $('#subscribers_count');
				if ($counter.size()>0){
					$counter.text(resp.subscribers_count);
				}
			}
		}, false, "json");
		return false;
	});

	app.onSubscribeButtonShow();

    $('button[href*="http"]').die('click').live('click', function(){
        location.href = $(this).attr('href');
    });

    iconAsyncLoader.loadIcons();
    window.setInterval(function(){
        iconAsyncLoader.loadIcons();
    }, 5000);    
    
    $.ajaxPrefilter(function( options, originalOptions, jqXHR ) {
		if (options.url.indexOf('.js')!=-1 || options.url.indexOf('.css')!=-1){
			return;
		}
        options.data="_page_url="+encodeURIComponent(app._page_url)+"&_page_ref="+encodeURIComponent(app._page_ref)+"&security_token="+app.user.session.security_token+"&"+options.data;
    });

    $.ajaxPrefilter( function( options, originalOptions, jqXHR ) {
        if (app.url!=app.upload_url && (options.url.indexOf(app.upload_url+'/_action')!=-1 || options.url.indexOf(app.upload_url+'/admin/_action')!=-1)){
            options.crossDomain ={
                crossDomain: true
            };
            options.xhrFields = {
                withCredentials: true
            };
        }
    });

    $('form').each(function(){
        if ($(this).find('[name="_page_url"]').size()==0){
            $(this).append($('<input>').attr({type: 'hidden', name: '_page_url', value: app._page_url}));
            $(this).append($('<input>').attr({type: 'hidden', name: '_page_ref', value: app._page_ref}));
            $(this).append($('<input>').attr({type: 'hidden', name: 'security_token', value: app.user.session.security_token}));
        }
    });

    var scrollFloatObj = new commonOperations.scrollFloatPanelMngClass({});
    scrollFloatObj.init();

	$('body').on('click.dropdown_menu', function(e){
		var $target = $(e.target);
        if ($('.dropdown_menu.active').size()>0 && !$target.is('.dropdown_menu') && $target.closest('.dropdown_menu').size()==0 && !$target.is('.ajax_tooltip') && $target.closest('.ajax_tooltip').size()==0){
			$('.dropdown_menu.active .visible_line .title').trigger('click');
		}
	})

	commonOperations.bindBaseActions();

	commonOperations.maskFieldsMng.initFields();
	commonOperations.initDatepickers();
	commonOperations.initClipboardCopy();
	commonOperations.bindSmartPlaceholders();
	commonOperations.initSmartPlaceholders();
	commonOperations.initParentRelationActions();
}

var iconAsyncLoader = {
    loaded: {},
    loadIcons: function(){
        var _this = this;
        var req_data = {};
        var size = 0;
        var MAX_PER_TIME = 100;
        $('[rel="async_icon"]').css({opacity: 0});
        $('[rel="async_icon"]').each(function(){
            var $this = $(this);
            if (size>=MAX_PER_TIME){
                return false;
            }
            if (!$this.hasClass('loaded')){
                var item_type = $this.data('icon_item_type');
                var item_id = $this.data('icon_item_id');
                var item_size = $this.data('icon_size');

                var loadedValue = _this.getValueFromCache(item_type, item_id, item_size);
                if (!loadedValue){
                    if (!_this.isset(req_data[item_type])){
                        req_data[item_type] = {};
                    }
                    if (!_this.isset(req_data[item_type][item_id])){
                        req_data[item_type][item_id] = {};
                    }
                    if (!_this.isset(req_data[item_type][item_id][item_size])){
                        req_data[item_type][item_id][item_size] = 1;
                        size++;
                    }
                }else{
                    _this.setSrc(item_type, item_id, item_size, loadedValue);
                }
            }
        });
        
        if (size){
            var post_data = {icons: req_data};
            $.ajPost(app.host+'/menu/get_icons_src', $.param(post_data), function(res){
                for (var item_type in res){
                    if (!_this.isset(_this.loaded[item_type])){
                        _this.loaded[item_type] = {};
                    }
                    for (var item_id in res[item_type]){
                        if (!_this.isset(_this.loaded[item_type][item_id])){
                            _this.loaded[item_type][item_id] = {};
                        }
                        for (var icon_size in res[item_type][item_id]){
                            if (!_this.isset(_this.loaded[item_type][item_id][icon_size])){
                                _this.loaded[item_type][item_id][icon_size] = res[item_type][item_id][icon_size];
                            }

                            _this.setSrc(item_type, item_id, icon_size, res[item_type][item_id][icon_size]);
                        }
                    }
                }
                _this.loadIcons();
            }, false, "json");
        }
    },

    setSrc:function(item_type, item_id, item_size, src){
        var $nodes = $('[data-uniqid="'+[item_type, item_id, item_size].join('_')+'"]');
        $nodes.each(function(){
            var $node = $(this);
            if (!$node.hasClass('loaded')){
                $node.css({opacity: 0}).removeAttr('rel').addClass('loaded');

                var img=new Image();
                img.onload = function(){
                    $node
                        .attr({src:src})
                        .css({opacity: 1});
                };
                img.src=src;
            }
        });
    },
    getValueFromCache: function(item_type, item_id, item_size){
        var value = false;
        if (this.isset(this.loaded[item_type]) && this.isset(this.loaded[item_type][item_id]) && this.isset(this.loaded[item_type][item_id][item_size])){
            value = this.loaded[item_type][item_id][item_size];
        }
        
        return value;
    },
    isset : function(obj){
        return typeof(obj)!="undefined";
    }
}

app.onSubscribeButtonShow = function(){
	$(document).ready(function(){
		setTimeout(function(){
			$('[rel="usubscribe"][data-mode="0"]').removeClass('start');
		}, 1000);
		$('[rel="usubscribe"][data-mode="0"]').die('mouseenter').live('mouseenter',
			function(){
				commonOperations.clearTimeouts(this, ['show-tmout', 'hide-tmout']);
				var _this = this;
				var onHover = function(){
					var $obj = $(_this);
					if ($obj.hasClass('focused')){
						return false;
					}
					var $text_container = $obj.find('i').size()>0 ? $obj.find('i') : $obj;
					var text = $text_container.text();
					$text_container.text($obj.data('hover_text'));
					$obj.data('hover_text', text);
					$obj.animate({opacity: 0.8}).removeClass('checked').addClass('focused');
				}
				if ($(_this).hasClass('start')){
					$(_this).removeClass('start');
					onHover();
				}else{
					var t = setTimeout(function(){
						onHover();
					}, 200);
					$(this).data('show-tmout', t);
				}
			}).die('mouseleave').live('mouseleave',
			function(){
				commonOperations.clearTimeouts(this, ['show-tmout', 'hide-tmout']);
				var _this = this;

				var t = setTimeout(function(){
					var $obj = $(_this);
					if ($obj.hasClass('checked')){
						return false;
					}
					var $text_container = $obj.find('i').size()>0 ? $obj.find('i') : $obj;
					var text = $text_container.text();
					$text_container.text($obj.data('hover_text'));
					$obj.data('hover_text', text);
					$obj.animate({opacity: 1}).addClass('checked').removeClass('focused');
				}, 100);
				$(this).data('hide-tmout', t);
			}
		);
	});
}

app.hasAccess=function(access_id, success_func, error_func, extra){
	$.ajGetJSON(app.host + '/menu/has_access/'+access_id, typeof(extra)!="undefined" ? extra : {}, function(resp){
		if (resp.access){
			if (success_func){
				success_func();
			}
		}else{
			if (error_func){
				error_func(resp);
			}else{
				app.showHeaderNotice(resp.text ? resp.text : 'Access denied');
			}
		}
	}, false);
}

app.checkForStatusNotice=function(type, extra){
	$.ajGetJSON(app.host + '/menu/check_status_notice/'+type, typeof(extra)!="undefined" ? extra : {}, function(resp){
		if (resp.show_notice){
			window.setTimeout(function(){
				app.showHeaderNotice(resp.text);
			}, 1000);
		}
	}, false);
}

app.showHeaderNotice=function(html){
	var t = $('#header').siblings('.notice_block').data('timeoutVar');
	if (t) window.clearTimeout(t);

	$('#header').siblings('.notice_block:hidden').remove();
	var $noticeBlock = $('<div class="notice_block"><div class="notice_block_inner">'+(html)+'</div></div>').hide();
	var $visible_blocks=$('#header').siblings('.notice_block');
	$noticeBlock.insertAfter('#header');
	
	$('html,body').animate({scrollTop:0});
	
	if($visible_blocks.length>1){
		$visible_blocks.remove();
		$noticeBlock.slideToggle();
	} else {
		swapBlocks($visible_blocks, $noticeBlock, 'fast');
	}

	var timeoutVar = window.setTimeout(function(){
		$noticeBlock.slideToggle();
	}, 10000);
	$noticeBlock.data('timeoutVar', timeoutVar);
}

jQuery.ajGetJSON=function(url, data, succ_fnc, load_fnc, async){
	if(typeof(load_fnc)=='undefined') $.screen_block(true);
	else if(load_fnc) load_fnc(0, null);
	
	return $.ajax({
	    type:'GET',
	    url:url,
	    data:data,
	    dataType:'json',
	    async: (typeof(async)=='undefined') ? true : async,
	    success:function(resp){
	    	if(typeof(load_fnc)=='undefined') $.screen_release(true);
			else if(load_fnc) load_fnc(1, resp);
			
			if(succ_fnc) succ_fnc(resp);
	    }
	});
}

jQuery.ajGet=function(url, data, succ_fnc, load_fnc){
	if(typeof(load_fnc)=='undefined') $.screen_block(true);
	else if(load_fnc) load_fnc(0, null);

	return $.get(url, data, function(resp){
		if(typeof(load_fnc)=='undefined') $.screen_release(true);
		else if(load_fnc) load_fnc(1, resp);
		
		if(succ_fnc) succ_fnc(resp);
	});
}

jQuery.ajPost=function(url, data, succ_fnc, load_fnc, dataType){
	var dataType = (typeof(dataType)=='undefined') ? "text" : dataType;
	if(typeof(load_fnc)=='undefined') $.screen_block(true);
	else if(load_fnc) load_fnc(0, null);

	return $.post(url, data, function(resp){
		if(typeof(load_fnc)=='undefined') $.screen_release(true);
		else if(load_fnc) load_fnc(1, resp);
		
		if(succ_fnc) succ_fnc(resp);
	}, dataType);
}

jQuery.ajForm=function(form_id, succ_fnc, load_fnc, extend_load_fnc, error_fnc, err_label_class, after_validate, force_sync){
	var form=$('#'+form_id).get(0);
	var $btn=$(form).find('button[type=submit] i');
	if($btn.length==0) $btn=$(form).find('button.submit:visible i');

	if(typeof(err_label_class)=='undefined') err_label_class='err_label';
	
	var options={
		async:force_sync ? false : true,
		beforeSubmit:function(arr, $form, options){
			if(typeof(extend_load_fnc)!='undefined'){
				if (!extend_load_fnc.call(form, arr, $form, options)){
					return false;
				}
			}
			
			if(typeof(load_fnc)=='undefined'){
				if($btn.length>0){
					if($btn.hasClass('idle')) return false;
					$btn.css({width:$btn.width()}).addClass('idle');
					$btn.data('txt', $btn.html()).html('&nbsp;').spin({radius:5, lines: 11, width: 3});
				} else {
					$.screen_block(true);
				}
			} else if(load_fnc) load_fnc(0, null, form);

			$(form).find('.error').removeClass('error');
			$(form).find('div.'+err_label_class+':not(.err_keep)').remove();
		},
		success:function(resp) {
			eval('var tmp='+resp+';');
			if(typeof(tmp['success'])!='undefined') var res=[tmp.success, tmp.errors];
				else var res=tmp;

			if(typeof(load_fnc)=='undefined'){
				if($btn.length>0){
					$btn.removeClass('idle').spin('remove').html($btn.data('txt'));
				} else {
					$.screen_release(true);
				}
			} else if(load_fnc) load_fnc(1, res, form);

			if(res[0]){

				if ($(form).find('textarea').size()>0 && $(form).find('textarea').data('redactor_wrapper')){
					$(form).find('textarea').data('redactor_wrapper').clearDraft();
				}

				if(succ_fnc) succ_fnc(res, form);
			} else {
                if(error_fnc) return error_fnc(res[1], form);

				if(typeof(res[1])=='string'){
					$.popup_alert({text:res[1], auto_hide:0})
				}else if(res[1] && res[1]['common']){
					$.popup_alert({text:res[1]['common'], auto_hide:0})
				} else {
					var focused=false;
					$.each(res[1], function(gid, errArr){
						var error=errArr[0];
						var elem=null;
						var parent_id=null;
						
						var tmp=gid.split('::');
						if(tmp.length>1){
							gid=tmp[1];
							parent_id=tmp[0];
						}

						if(form[gid]){
							elem=form[gid];
							var $parent=$(elem).closest('.field');
							if($parent.length==0) $parent=$(elem).parent();
						} else if($('#'+parent_id).length>0){
							elem=$('#'+parent_id).find(':input[name*='+gid+']:first');
							var $parent=$(elem).closest('.field');
							if($parent.length==0) $parent=$(elem).parent();
						} else if($('#'+gid).length>0){
							var $parent=$('#'+gid);
						}
						
						if($parent && $parent.length){
							showFormItemError($parent, error, err_label_class);

							if(!focused){
								if(elem && $(elem).is(':visible')){
									$(elem).focus();
									focused=true;
								} else if($parent.is(':visible')) {
									$('html,body').animate({scrollTop: ($parent.offset().top-10)});
									focused=true;
								}
							}
						}else{
							alert(error);
						}
					});
					
					if(after_validate) after_validate(res, form, focused);
				}
			}
		}
	}
	
	$('#'+form_id).ajaxForm(options);
}

showFormItemError=function($parent, error, err_label_class){
	if(typeof(err_label_class)=='undefined') err_label_class='err_label';
	
	var err_main_class=err_label_class.split(' ')[0];
	var errLabel=$("<div class='"+err_label_class+"'></div>").html("<div class='err_inner'><div class='err_arr'><span class='err_wrap'>"+error+"</span><span class='err_arr_h'></span></div></div>");
	
	var hide_fnc=function(){
		$(this).fadeOut('fast', function(){ $(this).remove(); });
	}
	
	if(!errLabel.hasClass('err_keep')) errLabel.click(hide_fnc.call(errLabel.get(0)));
	if(errLabel.hasClass('err_autohide')){
		setTimeout(function(){ hide_fnc.call(errLabel.get(0)) }, 3000);
	}
	
	if(!errLabel.hasClass('err_keep') || errLabel.hasClass('err_hide_on_click')){
		errLabel.click(function(){
			$(this).fadeOut('fast', function(){ $(this).remove(); });
		});
	}
	
	$parent.find('.'+err_main_class).remove();
	
	$parent
		.addClass('error')
		.append(errLabel)
		.bind('click keyup mousedown mouseup', function(){
			if(!errLabel.hasClass('err_keep')) hide_fnc.call(errLabel.get(0));
		});
		
	return errLabel;
}

mlClick=function(e){
	return (((!$.browser.msie && e.button == 0) || ($.browser.msie && e.button == 0)) && !(e.ctrlKey || e.shiftKey || e.metaKey));
}

jQuery.fn.extend({
	escapeLinks:function(){
		return this.each(function(){
			$(this).find('a').not('.no_escape').click(function(evt){
				evt.stopPropagation();
				return true;
			});
		});
	},
	enter:function(fnc){
		if(!fnc) return false;
		return this.each(function(){
			$(this).keypress(function(e){
				if(e.keyCode == 13) {
			        fnc.call(this, e);
			        return false;
			    }
			});
		});
	},
	limitMaxlength:function(options){
		var settings = jQuery.extend({
				attribute: "maxlength",
				onLimit: function(){},
				onEdit: function(){}
			}, options);
		
		// Event handler to limit the textarea
		var onEdit = function(){
			var textarea = jQuery(this);
			var maxlength = parseInt(textarea.attr(settings.attribute));
			if(textarea.val().length > maxlength){
				textarea.val(textarea.val().substr(0, maxlength));
				jQuery.proxy(settings.onLimit, this)();
			}
			jQuery.proxy(settings.onEdit, this)(maxlength - textarea.val().length);
		}
		
		this.each(onEdit);
		
		return this.keyup(onEdit).keydown(onEdit).focus(onEdit);
	},
	captureChange:function(process_fnc, res_fnc, maxlength, error_fnc){
		if(!process_fnc || !res_fnc) return false;
		
		return this.each(function(){
			var $this=$(this);
			
			var on_dummy_paste=function($dummy, sel){
				var dummy_html=strip_tags($dummy.html(), '<b><i><u><a><p><div><br><strong>');
				$dummy.remove();
				$this.focus();
				rangy.restoreSelection(sel);
				
				if(maxlength>0){
					//Test if data length overhead allowed
					var check=window['cclv'].replace(/<[^>]+>/igm, '');
					var dummy_check=dummy_html.replace(/<[^>]+>/igm, '');
					if((check.length+dummy_check.length)>=maxlength){
						var chunked=html_truncate(dummy_html, maxlength-check.length, '');
						dummy_html=chunked[0];
					}
				}
				var node=$('<span>'+process_fnc.call($this, dummy_html)+'</span>').get(0);
				insertNodeAtCaret(node, true);
				res_fnc.call($this, $this.html());
			}
		
			$this.keydown(function(e){
				window['cclv']=$this.html();

				var tech_key=false;
				if(
					(array_has([37, 38, 39, 40, 8, 16, 17, 18, 33, 34, 35, 36, 37, 38, 39, 40, 45, 46], e.which)) ||
					(array_has([65, 67, 86], e.which) && e.ctrlKey)
				){
					tech_key=true;
				}

				if(maxlength>0 && !tech_key){
					//Test if data length overhead allowed
					var check=window['cclv'].replace(/<[^>]+>/igm, '');

					if(check.length>=maxlength){
                        if (error_fnc){
                            error_fnc($this, {error_type: 'maxlength', excess: check.length-maxlength+1});
                        }
                        return false;
                    }
				}
			}).keyup(function(e){
				if(window['cclv']!=$this.html()){
					var sel=rangy.saveSelection(window);
                    var processed_html = process_fnc.call($this, $this.html());
                    if($this.html()!=processed_html){
                        $this.get(0).innerHTML = processed_html;
                    }
					rangy.restoreSelection(sel);
					res_fnc.call($this, $this.html());
				}
			}).bind('paste', function(){
				window['cclv']=$this.html();
				var sel=rangy.saveSelection(window);
				var $dummy=$('<div contenteditable="true" style="position:fixed; width:10px; height:10px; left:-1000px; top:0;"></div>').appendTo(document.body).focus();
				
				setTimeout(function(){ on_dummy_paste($dummy, sel); }, 1);
			});
		});
	},
	setNew:function(new_color, clean, complete){
		if(!new_color) new_color='#FFFFFF';
		
		if(!complete){
			complete=false;
			if(clean) complete=function(){$(this).css('backgroundColor', '')};
		}
		
		return this.each(function(){
			$(this).animate({backgroundColor:new_color}, {duration:5000, queue:false, complete:complete});
		});
	},
	slideIn:function(duration, initHeight, fade, animateScroll, scrollCheck, toggleVisible, fnc, $scroll){
		if(!initHeight) initHeight=0;
		if(typeof(fade)=='undefined') fade=true;
		
		return this.each(function(){
			var $this=$(this);
			var winSt=$(window).scrollTop();
			$this.css({visibility:'hidden', display:'block'});
			var h=$this.outerHeight();
			var mT=parseInt($this.css('marginTop'), 10);
			var mB=parseInt($this.css('marginBottom'), 10);
			var totalH=h+mT+mB;
			var pd=parseInt($this.css('padding-top'), 10)+parseInt($this.css('padding-bottom'), 10);
			var of=$this.offset();

			if(h>0){
				if(of.top<winSt){
					$this.css({visibility:'', height:'', display:'block'});
					if(animateScroll) $('html,body').scrollTop(winSt+totalH);
					if(fnc) fnc.call($this);
				} else {
					var options={
						duration:duration,
						queue:false,
						complete:function(){
							$this.css({visibility:'', height:'', marginTop:'', marginBottom:'', display:'block'});
							if(fnc) fnc.call($this);
						}
					};
					var animateH=totalH-pd;
					
					if($scroll){
						var maxH=parseInt($scroll.css('maxHeight'), 10);
						var msglH=$scroll.outerHeight();
						var sAnimateH=msglH+totalH-initHeight;
						
						if($scroll.attr('anH')>0){
							$scroll.stop(false, false);
							sAnimateH=$scroll.attr('anH')+totalH;
						}
						
						$scroll.attr('anH', sAnimateH);
						$scroll.find('.jspContainer').animate({height:Math.min(sAnimateH, maxH)}, {duration:duration, queue:false, complete:function(){
							$scroll.attr('anH', null).data('jsp').reinitialise();
						}});
					}
					
					$this.css({height:initHeight+'px', marginTop:'0px', marginBottom:'0px', visibility:'', display:fade?'none':'block'});
					$this.animate({height:animateH-mT-mB, marginTop:mT, marginBottom:mB}, options);
					
					if(fade) $this.fadeIn(duration);
					
					if(toggleVisible) $this.css({overflow:'visible'});
					
					if(scrollCheck && of.top>winSt) animateScroll=false;
					if(animateScroll){
						$('html,body').animate({scrollTop:winSt+totalH+'px'}, {duration:duration, queue:false, easing:'linear'});
					}
				}
			} else {
				$this.css({visibility:'', height:'', display:'block'});
				if(fnc) fnc.call($this);
			}
		});
	},
	scrollFade:function(duration, scrollCheck){
		return this.each(function(){
			var $this=$(this);
			var winSt=$(window).scrollTop();
			$this.css({visibility:'hidden', display:'block'});
			var h=$this.outerHeight(true);
			var of=$this.offset();

			if(h>0){
				$this.css({visibility:'', display:'none'});
				$this.fadeIn(duration, function(){
					$this.css({visibility:'', height:'', display:'block'});
				});
				$this.css({overflow:'visible'});
				
				animateScroll=true;
				if(scrollCheck && of.top>winSt) animateScroll=false;
				if(animateScroll) $('html,body').scrollTop(winSt+h);
			}
		});
	},
	outerHTML:function(s){
		return (s) ? this.before(s).remove() : $("<p>").append(this.eq(0).clone()).html();
	},
	scrollable:function(options){
		var settings = jQuery.extend({
				verticalGutter:0,
				verticalArrowPositions:'os'
			}, options);

		return this.each(function(){
			$(this)
				.jScrollPane(settings)
				.bind('mousewheel', function(e){
					e.preventDefault();
					e.stopPropagation();
					return false;
			    });		
		});
	},
	hasScrollBar:function(){
        return this.get(0).scrollHeight > this.height();
    },
    outerHTML:function() {
		return $( $('<div></div>').html(this.clone()) ).html();
	},
	spin:function(options){
		var settings = jQuery.extend({
			lines: 13, // The number of lines to draw
			length:0, // The length of each line
			width: 4, // The line thickness
			radius: 7, // The radius of the inner circle
			rotate: 0, // The rotation offset
			color: '#000', // #rgb or #rrggbb
			speed: 1, // Rounds per second
			trail: 60, // Afterglow percentage
			shadow: false, // Whether to render a shadow
			hwaccel: false, // Whether to use hardware acceleration
			className: 'spinner', // The CSS class to assign to the spinner
			zIndex: 2e9, // The z-index (defaults to 2000000000)
			top: 'auto', // Top position relative to parent in px
			left: 'auto' // Left position relative to parent in px
		}, options);

		return this.each(function(i, node){
			if(options=='remove'){
				$(node).data('spinner').stop();
			} else {
				$(node).data('spinner', new Spinner(settings).spin(node));
			}
		});
	},
	counterh:function(options){
		options = options || {autohide: false};
		
		return this.each(function(){
			var maxlength=options.maxlength?options.maxlength:$(this).attr('maxlength');
			var $counter=$(this).find('.counterh');

			$(this).find('input[type=text]').keyup(function(){
				var avail=parseInt(maxlength-this.value.trim().length, 10);
				$counter.html(avail);
				if(avail>0) $counter.removeClass('counterhe');
					else $counter.addClass('counterhe');
                if (options.autohide && avail>5){
                    $counter.hide();
                }else{
                    $counter.show();
                }
			});

            if (options.autohide && $counter.text()>5){
                $counter.hide();
            }else{
                $counter.show();
            }
		});
	},
	gid:function(options){
		options = options || {};
		
		return this.each(function(){
			$(this).find('input[type=text]')
				.keyup(function(){
					var $this=$(this);
					var new_value=$this.val();
					var start = this.selectionStart, end = this.selectionEnd, offset=0;
					
					//Replace all spaces with -, and translit
					new_value=new_value.replace(/\s/g, "-").translit();
					offset=new_value.length-$this.val().length;
					
					//Remove all invalid symbols
					new_value=new_value.replace(/[^0-9a-zA-Z\-_]/g, "");
					new_value=new_value.replace(/(\-+)/g, "-");
					$this.val(new_value);
					
					start=start+offset;
					end=end+offset;
					this.setSelectionRange(start, end);
				});
		});
	},
	tabs:function(options){
		options = options || {};
		
		return this.each(function(){
			var $root=$(this).hasClass('tabs')?$(this):$(this).closest('.tabs');
		
			$root.find('ul.tabs_menu a').click(function(){
				var $this=$(this);
				var href=$this.attr('href');
				
				if(href && href.indexOf('javascript')!=0) app.set_url(getAppUrl(this));
				
				$root.find('ul.tabs_menu li').removeClass('selected');
				$this.closest('li').addClass('selected');
				$root.find('.tab').hide();
				$root.find('.tab#'+$this.attr('rel')).show();
				return false;
			});
		});
	},
	autocomplete:function(options){
		if ($(this).data('autocompleted')){
			return false;
		}

		$(this).data('autocompleted', 1);

	    	options = options || {allow_empty: true, limit_count: 0, onLoad: false, beforeOnLoad: false, onEmptyField: false, custom_scroll: false, autostart: false};
		if(!options['timeout_ms']) options.timeout_ms=500;

        if (options['custom_scroll']){
            app.loadStatic(['jquery/scroll_v2/jquery.mCustomScrollbar.concat.min.js', 'jquery/scroll_v2/jquery.mCustomScrollbar.css'], true);
        }
		
		return this.each(function(){
			var $this=$(this);
			$this.attr('autocomplete', 'off');
			var $field=$this.closest('.field');
			var $parent=$('<div class="acm_area hidden"></div>').insertAfter(this);
			var $hidden=options.hidden ? $('<input type="hidden" name="'+options.hidden+'" value="'+($(this).data('default') ? $(this).data('default') : "")+'">').insertAfter(this) : false;
			var $loader=$(this).closest('form').find('.loading');
			var prev_value=false;

			if($loader.length==0) $loader=false;
			$parent.data('input', $this);
			
			var pckrLoad=function(searchq){
				if (searchq=='' && !options.allow_empty){
                    if (options.onEmptyField){
                        options.onEmptyField();
                    }
					return false;
				}

				if($loader) $loader.css({display:'block'});

				var sendData={searchq:searchq};
				if (options.modifyPost){
					sendData=options.modifyPost.call($this, sendData);
				}
									
				if (options.limit_count){
					sendData['limit_count'] = options.limit_count;
				}

                if ($parent.data('xhr')){
                    $parent.data('xhr').abort();
                }

				var xhr = $.ajax({
				    type:'POST',
				    url:options.url,
				    data:sendData,
				    dataType:'json',
				    success:function(res){
                        if (options.beforeOnLoad){
                            options.beforeOnLoad(res);
                        }
				    	if($loader) $loader.css({display:'none'});

                        if (options.onLoad){
                            options.onLoad(res);
                            return false;
                        }

						if(res.items_count==0){
							$parent.slideUp('fast', function(){
								$(this).html('');
							})
							$field.addClass('autocomplete_error');
						} else {
							$field.removeClass('autocomplete_error');

							$parent.html(res.html);
                            if (options['custom_scroll']){
                                $parent.find('.acm_items').mCustomScrollbar({
                                    axis: 'y',
                                    theme: 'dark-3'
                                });
                            }
							$parent.find('a.pick').click(function(e){
                                var $acm_item = $(this).closest('.acm_item');
                                if ($acm_item.hasClass('not_available')){
                                    app.showTooltip($acm_item, $acm_item.data('not_available_reason'), 'error', {'class_name':'autocomplete'});
                                    return false;
                                }
								var opt_value=$(this).attr('pick');
								var $value_field = $(this).find('.acm_item_value');
								var opt_text=$value_field.data('label') ? $value_field.data('label') : $value_field.text();
								
								if (options.onSelect){
									options.onSelect($this, $(this), opt_value, opt_text);
								}else{
									$this.val(opt_text).removeClass('inp_inactiv');
                                    $this.trigger('change');
								}

								setHiddenValue($this, $hidden, opt_value);

								$parent.slideUp('fast');
								return false;
							});
							$parent.find('.acm_item').hover(
								function(){$parent.find('.acm_item_hover').removeClass('acm_item_hover'); $(this).addClass('acm_item_hover');},
								function(){$(this).removeClass('acm_item_hover')}
							);
							
							if(res.items_count==1){
								$parent.find('.acm_item:first').addClass('acm_item_hover');
							}
							
							if($parent.is(':hidden')){
								$parent.slideIn('fast', 0, true, false, false, false, function(){
									$this.data('tm', 0);
								});
							} else {
								$this.data('tm', 0);
							}
						}
				    }
				});

                $parent.data('xhr', xhr);
			};

			var setHiddenValue = function($input, $hidden, value){
				if($hidden){
					$hidden.val(value).change();
				}
				if (value != 0){
					$input.addClass('choosen');
				}else{
					$input.removeClass('choosen');
				}
			}

			$(this).keydown(function(e){
				if(e.keyCode==13){
					e.preventDefault();
				}
			});

			$(this).keyup(function(e){
				if(e.keyCode==40){
					var $node=$parent.find('.acm_item_hover');
					$node=($node.length==0) ? $parent.find('.acm_item:first') : $node.next('.acm_item');
					if($node.length>0){
						$parent.find('.acm_item_hover').removeClass('acm_item_hover');
						$node.addClass('acm_item_hover');
					}
				} else if (e.keyCode==38){
					var $node=$parent.find('.acm_item_hover');
					$node=($node.length==0) ? $parent.find('.acm_item:first') : $node.prev('.acm_item');
					if($node.length>0){
						$parent.find('.acm_item_hover').removeClass('acm_item_hover');
						$node.addClass('acm_item_hover');
					}
				} else if(e.keyCode==13){
					var $node=$parent.find('.acm_item_hover a.pick');
					if($node.length>0){
						e.preventDefault();
						$node.trigger('click');
						$parent.slideUp('fast');
					} else {
						$node=$parent.find('.acm_item_hover a.view');						
						if($node.length>0) triggerClick($node.get(0), e);
					}
				} else if(prev_value!=$this.val()){
					setHiddenValue($this, $hidden, 0);
					if($this.data('tm')) clearTimeout($this.data('tm'));

					$this.data('tm', setTimeout(function(){
						pckrLoad($this.val());
					}, options.timeout_ms));
				}
				prev_value=$this.val();
			}).click(function(e){
				var searchq=$this.hasClass('inp_inactiv') ? '' : $this.val();
				pckrLoad(searchq);
			}).bind('paste cut', function(){
				setTimeout(function(){
					setHiddenValue($this, $hidden, 0);
					pckrLoad($this.val());
			    }, 100);
			});
			
			$parent.add($this).bind('mousedown', function(e){
				e.stopPropagation();
			});
			
			$(document).bind('mousedown', function(){
				if($parent.length>0 && $parent.is(':visible')){
					if($this.data('tm')) clearTimeout($this.data('tm'));
					$parent.slideUp('fast');
				}
			});



            if (options.autostart && options.allow_empty){
                pckrLoad('');
            }
		});
	},
	tmchange:function(options){
		options = options || {fnc:false, onenter:false, root:false};
		if(!options['timeout_ms']) options.timeout_ms=1000;
	
		return this.each(function(){
			var $this=$(this);
			var type=this.type.toLowerCase();
			var prev_value=(type=='checkbox')?(this.checked?1:0):$this.val();
			var $root=options['root']?options['root']:$this;
			$this.bind("click change keyup paste cut", function(){
				setTimeout(function(){
					var new_value=(type=='checkbox')?($this.get(0).checked?1:0):$this.val();

					if ($this.data('value')){
						prev_value=$this.data('value');
					}

					if(prev_value!=new_value || $this.hasClass('_force')){
                        $this.removeClass('_force')

						prev_value=new_value;
						$this.data('value', prev_value);

						if(typeof(options['onenter'])=="function") options.onenter.call($this.get(0), $this.val());
						if($root.data('tm')>0) clearTimeout($root.data('tm'));

						if(options.fnc){
							$root.data('tm', setTimeout(function(){
								options.fnc.call($this.get(0), $this.val());
							}, options.timeout_ms));
						}
					}
				}, 100);
			});
		});
	},
	hoverMenu:function(){
		return this.each(function(i, node){
			$(node).hover(
				function(){ $(this).addClass('active') },
				function(){ $(this).removeClass('active') }
			);
			
			$(node).find('.hovermenu_list li').hover(
				function(){ 
					$(this).prev('li').addClass('hover_pre');
					$(this).addClass('hover');
				},
				function(){ 
					$(this).prev('li').removeClass('hover_pre');
					$(this).removeClass('hover');
				}
			);
		});
	},
	hoverHint:function(params){
		params=params || {};
		
		var onEnter=function(){
			var _this=$(this);
			var relNode=_this;
			var error=_this.data('hint_text');
            if (!error){
                return;
            }
			var css={
				display:'none',
				zIndex:1000
			};
			
			var errLabel=$("<div class='err_hint err_arr_right global_err_hint'></div>").html("<div class='err_inner'><div class='err_arr'><span class='err_wrap'>"+error+"</span><span class='err_arr_h'></span></div></div>");
			errLabel.appendTo(document.body);
			
			if(params.pos=='left'){
				css.left=relNode.offset().left-errLabel.width()-params.xoffset;
				if(params.align=='center') css.top=relNode.offset().top+(relNode.height()-errLabel.height())/2;
				else if(params.align=='bottom') css.top=relNode.offset().top+relNode.height();
				else css.top=relNode.offset().top;
				
				if(params.yoffset) css.top=css.top-params.yoffset;
			}

            errLabel.css({opacity: 0});
			errLabel.css(css).fadeIn('fast');

            window.setTimeout(function(){errLabel.animate({opacity: 1});}, 500);
			
			_this.data('err', errLabel);

            
            _this.data('checker', window.setInterval(function(){            
                if (!relNode.is(':visible')){
                    errLabel.fadeOut(function(){$(this).remove()});
                }
            }, 1000));
		}
		
		var onLeave=function(){ 
			if($(this).data('err')){
				$(this).data('err').fadeOut('fast', function(){ $(this).remove(); })
                window.clearInterval($(this).data('checker'));
			}
		};
		
		return this.each(function(){
			if(params.use_hover){
				$(this).hover(onEnter, onLeave);
			} else {
				$(this).on({
					mouseenter:onEnter,
					mouseleave:onLeave
				}, params.selector);
			}
		});
	},
	serializeObject:function(){

        var self = this,
            json = {},
            push_counters = {},
            patterns = {
                "validate": /^[a-zA-Z][a-zA-Z0-9_]*(?:\[(?:\d*|[a-zA-Z0-9_]+)\])*$/,
                "key":      /[a-zA-Z0-9_]+|(?=\[\])/g,
                "push":     /^$/,
                "fixed":    /^\d+$/,
                "named":    /^[a-zA-Z0-9_]+$/
            };


        this.build = function(base, key, value){
            base[key] = value;
            return base;
        };

        this.push_counter = function(key){
            if(push_counters[key] === undefined){
                push_counters[key] = 0;
            }
            return push_counters[key]++;
        };

        $.each($(this).serializeArray(), function(){

            // skip invalid keys
            if(!patterns.validate.test(this.name)){
                return;
            }

            var k,
                keys = this.name.match(patterns.key),
                merge = this.value,
                reverse_key = this.name;

            while((k = keys.pop()) !== undefined){

                // adjust reverse_key
                reverse_key = reverse_key.replace(new RegExp("\\[" + k + "\\]$"), '');

                // push
                if(k.match(patterns.push)){
                    merge = self.build([], self.push_counter(reverse_key), merge);
                }

                // fixed
                else if(k.match(patterns.fixed)){
                    merge = self.build([], k, merge);
                }

                // named
                else if(k.match(patterns.named)){
                    merge = self.build({}, k, merge);
                }
            }

            json = $.extend(true, json, merge);
        });

        return json;
    }
});

$.deparam= function(params, coerce){
	var obj = {},
		coerce_types = { 'true': !0, 'false': !1, 'null': null };

	$.each(params.replace(/\+/g, ' ').split('&'), function (j,v) {
		var param = v.split('='),
			key = decodeURIComponent(param[0]),
			val,
			cur = obj,
			i = 0,

			// If key is more complex than 'foo', like 'a[]' or 'a[b][c]', split it
			// into its component parts.
			keys = key.split(']['),
			keys_last = keys.length - 1;

		// If the first keys part contains [ and the last ends with ], then []
		// are correctly balanced.
		if (/\[/.test(keys[0]) && /\]$/.test(keys[keys_last])) {
			// Remove the trailing ] from the last keys part.
			keys[keys_last] = keys[keys_last].replace(/\]$/, '');

			// Split first keys part into two parts on the [ and add them back onto
			// the beginning of the keys array.
			keys = keys.shift().split('[').concat(keys);

			keys_last = keys.length - 1;
		} else {
			// Basic 'foo' style key.
			keys_last = 0;
		}

		// Are we dealing with a name=value pair, or just a name?
		if (param.length === 2) {
			val = decodeURIComponent(param[1]);

			// Coerce values.
			if (coerce) {
				val = val && !isNaN(val)              ? +val              // number
					: val === 'undefined'             ? undefined         // undefined
						: coerce_types[val] !== undefined ? coerce_types[val] // true, false, null
							: val;                                                // string
			}

			if ( keys_last ) {
				// Complex key, build deep object structure based on a few rules:
				// * The 'cur' pointer starts at the object top-level.
				// * [] = array push (n is set to array length), [n] = array if n is
				//   numeric, otherwise object.
				// * If at the last keys part, set the value.
				// * For each keys part, if the current level is undefined create an
				//   object or array based on the type of the next keys part.
				// * Move the 'cur' pointer to the next level.
				// * Rinse & repeat.
				for (; i <= keys_last; i++) {
					key = keys[i] === '' ? cur.length : keys[i];
					cur = cur[key] = i < keys_last
						? cur[key] || (keys[i+1] && isNaN(keys[i+1]) ? {} : [])
						: val;
				}

			} else {
				// Simple key, even simpler rules, since only scalars and shallow
				// arrays are allowed.

				if ($.isArray(obj[key])) {
					// val is already an array, so push on the next value.
					obj[key].push( val );

				} else if (obj[key] !== undefined) {
					// val isn't an array, but since a second value has been specified,
					// convert val into an array.
					obj[key] = [obj[key], val];

				} else {
					// val is a scalar.
					obj[key] = val;
				}
			}

		} else if (key) {
			// No value was defined, so set something meaningful.
			obj[key] = coerce
				? undefined
				: '';
		}
	});

	return obj;
}

getQajxUrl=function(href) {
	var pathname=href.pathname.ltrim('\/');
	return ((app['qajx_prefix']>0)?(pathname.substring(app.qajx_prefix)):pathname)+href.search;
}

getQueryUrl=function(url){
	if(url.indexOf(app.url)==0) url=url.substr(app.url.length);
	return url.ltrim('\/');
}

getAppUrl=function(href){
	return getQajxUrl(href);
}

getUrlParams=function(url, prefix){
    var params = {};

    var urlparts=url.split('?');
    if (urlparts.length>=2) {
        var pars=urlparts[1].split(/[&;]/g);
        for (var i in pars){
            var t = pars[i].split('=');
            var key=t[0]; var value=t[1];            
           if ((typeof (prefix) == "undefined") || key.indexOf(prefix, 0)!==-1){
               params[key] = value;
           }
        }        
    }

    return params;
}
removeUrlParams=function(url, prefix){
	var urlparts=url.split('?');
	if (urlparts.length>=2) {
		var pars=urlparts[1].split(/[&;]/g);
		for (var i= pars.length; i-->0;){
			if (pars[i].lastIndexOf(prefix, 0)!==-1) pars.splice(i, 1);
		}
		url= urlparts[0]+(pars.length>0?('?'+pars.join('&')):'');
	}
	
	return url;
}

addUrlParams=function(url, params){
	$.each(params, function(key, value){
		url=removeUrlParams(url, key);
	});
	
	var urlparts=url.split('?');
	var pars=(urlparts.length>=2)?urlparts[1].split(/[&;]/g):[];
	$.each(params, function(key, value){
		pars[pars.length]=key+'='+value;
	});
	url= urlparts[0]+(pars.length>0?('?'+pars.join('&')):'');
	
	return url.ltrim('\/');
}

replaceUrlParam=function(url, prefix, new_val){
	var urlparts=url.split('?');
	if (urlparts.length>=2) {
		var pars=urlparts[1].split(/[&;]/g);
		for (var i= pars.length; i-->0;){
			if (pars[i].lastIndexOf(prefix, 0)!==-1) pars[i]=pars[i].substr(0, pars[i].indexOf('='))+'='+new_val;
		}
		url= urlparts[0]+(pars.length>0?('?'+pars.join('&')):'');
	}
	
	return url;	
}

refreshInnerText=function($node, inner_text, by_queue, transition_class){
	if (typeof(by_queue)=="undefined") by_queue=false;
	if (typeof(transition_class)=="undefined") transition_class='inner';
	if(!$node || $node.length==0 || $node.find('span').html()==inner_text) return false;

	if($node.is(':hidden')){
		$node.find('span').html(inner_text);
	} else {
		var $inner=$('<span style="display:none;">'+inner_text+'</span>');
		var show_fnc = function(){
			$node.append($inner);
			$inner.fadeIn('fast');
		}
		$node.find('span').addClass(transition_class).fadeOut('fast', function(){
			$node.find('.'+transition_class).remove();
			if (by_queue) show_fnc();
		});

		if (!by_queue) show_fnc();
	}
}

ratingFormat=function(rating){
    if (app.user.ui && app.user.ui['ui_prm_rating_rounding']=='0'){
        rating = Number(rating);

    }else{
        rating = parseFloat(rating);
        if (rating > -0.5 && rating< 0.5 && rating!=0){
            rating = rating.toFixed(1);
        }else{
            rating = Math.round(rating);
        }
    }

    return rating;
}

refreshRate=function($rate, rating){
    rating = ratingFormat(rating);

	if(!$rate || $rate.length==0 || $rate.find('span').html()==(rating+'')) return false;

    var rating_str = ($rate.hasClass('with_sign') && rating > 0) ? '+'+rating : ''+rating;

	if($rate.find('span').length==0){
		$rate.html(rating_str);
	} else if($rate.is(':hidden')){
		$rate.find('span').html(rating_str);
	} else {
		var $inner=$('<span style="display:none;">'+rating_str+'</span>');
		$rate.find('span').addClass('inner').fadeOut('fast', function(){
			$rate.find('.inner').remove();
		});
		$rate.append($inner);
		$inner.fadeIn('fast');
	}
	
	$rate.removeClass('rating_none').removeClass('rating_like').removeClass('rating_dislike');
	if(rating>0) $rate.addClass('rating_like');
	else if(rating<0) $rate.addClass('rating_dislike');
	else $rate.addClass('rating_none');
}

buttonIdleSwitch=function($btn, mode, options){
	if (typeof(options) == "undefined"){
		options = {};
	}
	if ($btn.find('i').size()>0){
		$btn = $btn.find('i');
	}

	if (mode){
		$btn.addClass('idle');
		window.setTimeout(function(){
			if ($btn.hasClass('idle')){
				$btn.css({width:$btn.width()});
				if (options.bg_img){
					$btn.data('bg_img', $btn.css('backgroundImage')).css('backgroundImage', 'none');
				}
				$btn.data('txt', $btn.html()).html('&nbsp;').spin({lines:13, width: 2, radius: 6, color: ($btn.parents('#iviewer').size()>0 ? '#FFFFFF' : '#000000')});
				$btn.data('idle_on', true);
			}
		}, 300);
	}else{
		$btn.removeClass('idle');
		if ($btn.data('idle_on')){
			$btn.spin('remove').html($btn.data('txt'));
			if (options.bg_img){
				$btn.css('backgroundImage', $btn.data('bg_img'))
			}
		}
	}
}

var voteOperationsClass = function(){

    var default_options = {
        global_id : '',
        vote_block_sel: '.pst_menu',
        item_class_sel: '.item',
        item_id: '',
        item_id_prefix: '',
        action_url : '',
        extra : {}
    }

    var _objMng = function(){

    };

    _objMng.prototype = {
        ajax_status : null,
        action_url : '',
        id: 0,
        item_jq_obj : null,
        popup_sel : '.vote_reason_form',
        options: {},
        bindVoteButtons : function(params_in){
            var params = $.extend({}, default_options, params_in);

            var vote_block_sel = '#'+params.global_id+' '+ params.vote_block_sel;

            this.bindRatingDetailsDisplaying(params);

            $(vote_block_sel +' a.like,'+vote_block_sel+' a.dislike').die('click').live('click', function(){
                var $node=$(this);
                var $parent=$node.closest(params.item_class_sel);

                if ($parent.is('.cm')){
                    if($node.hasClass('like_dis') || $node.hasClass('like_active') || $node.hasClass('dislike_dis') || $node.hasClass('dislike_active')) return false;
                }

				if (params_in.get_item_id_func){
					params.item_id = params_in.get_item_id_func.call(this, $parent);
				}else if (typeof(params_in.item_id_prefix)!="undefined" && params_in.item_id_prefix != ''){
                    params.item_id = $parent.attr('id').replace(params.item_id_prefix, '');
                }

				if (params_in.get_action_url_func){
					params.action_url = params_in.get_action_url_func.call(this, $parent)
				}

                var like=$node.hasClass('like')?1:0;
                var id=params.item_id;

                params.extra['vote_block_sel'] = params.vote_block_sel;
                params.extra['item_class_sel'] = params.item_class_sel;

                voteOperations.trySetVote(params.action_url, id, like, $parent, params.extra);
            });
        },

        bindRatingDetailsDisplaying	: function(params){
            var vote_block_sel = '#'+params.global_id+' '+ params.vote_block_sel;
            var popupDetailsMng = {
                field	: vote_block_sel +' .rating',
                clearLoadTimeout: function(obj){
                    if ($(obj).data('timeout')){
                        clearTimeout($(obj).data('timeout'));
                    }
                },
                clearHideTimeout: function(obj){
                    if ($(obj).data('hide_timeout')){
                        clearTimeout($(obj).data('hide_timeout'));
                    }
                },
                hideDetailsBlocks : function(obj){
                    var $block = $('.rating_details[data-item="'+$(obj).closest('.cm, .item').attr('id')+'"]');
                    $block.fadeOut(function(){
                        $(this).remove();
                    });
                },
                showDetailsBlock : function(block){
                    block.fadeIn();
                },
                createDetailBlock	: function(obj){
                    var $obj = $(obj);
                    var container = $obj.closest('.cm, .item');
                    var $container = $(container);
                    var $div = $('<div></div>');

                    var position = this.getPositionToShow($obj);

					$container.after($div);

                    var offset = {
                        top : ($obj.offset()).top,
                        left: ($obj.offset()).left
                    }

					if ($div.offsetParent().size()>0){
						var $t = $div.offsetParent();
						if ($t.size()>0 && !$t.is('body')){
							offset.top = offset.top - $t.offset().top,
							offset.left = offset.left - $t.offset().left
						}
					}

					$div.data('offset', offset);
					$div.data('correction', {
						top: ($obj.offset()).top - offset.top,
						left: ($obj.offset()).left - offset.left
					});

					$div.hide()

                    $div.css(
                        {top : offset.top, left: offset.left}
                    ).addClass('ajax_tooltip rating_details position_'+position).data('position', position);


                    var container_id = $container.attr('id');
                    if (!container_id){
                        container_id = 'id_'+generateRandomId();
                        $container.attr('id', container_id);
                    }

                    var obj_uid = generateRandomId();
                    $obj.attr('data-uid', obj_uid);
                    $div.attr('data-uid', obj_uid);

                    $div.attr('data-item', container_id);

                    return $div;
                },
                showProgress	: function($block){
                    $block.append($('<div></div>').addClass('loading_indicator'));
                    app.switchProgress($block.find('.loading_indicator'), true, {radius: 18, lines:13, width: 7, color: '#000000', speed: 1, top: 25, left: 25});

                    var height_delta = $block.height()+12+5;

					var offset = $block.data('offset');

					var position = {
						top : parseInt($block.css('top')) - ($block.data('position')=='top' ? height_delta : -22-12-4),
						left: offset.left - ($block.outerWidth()-110)/2
					}
                    $block.css(
                        position
                    );
                },
                getPositionToShow	: function($obj){
                    var free_space = {
                        top: $obj.offset().top - $(window).scrollTop(),
                        bottom: $(window).scrollTop()+$(window).height()-$obj.offset().top-$obj.height()
                    }
                    var REQUIRE_SPACE = 245;
                    var position = 'top';
                    if (free_space.top<REQUIRE_SPACE && free_space.top<free_space.bottom){
                        position = 'bottom';
                    }

                    return position;
                },
                loadDetailForm	: function(obj){
                    var TIME_TO_SHOW_PROGRESS_MS = 300;

                    var $block =  this.createDetailBlock(obj);
                    $block
                        .on('mouseenter', function(){
                            popupDetailsMng.clearHideTimeout($('[data-uid="'+$block.attr('data-uid')+'"]'));
                        })
                        .on('mouseleave', function(){
							$('[data-uid="'+$block.attr('data-uid')+'"]').each(function(){
								if (!$(this).is($block)){
									$(this).trigger('mouseleave');
								}
							});
                        });

                    this.showProgress($block);

                    $block.css('opacity', 0);
                    popupDetailsMng.showDetailsBlock($block);

                    window.setTimeout(function(){
                        if ($block.size())
                            $block.animate({opacity : 1});
                    }, TIME_TO_SHOW_PROGRESS_MS);

                    var xhr = $.ajPost('/menu/vote_details', {type: $(obj).attr('data-type'), id: $(obj).attr('data-id')}, function(resp){
                        $block.wrapInner('<div class="inner" style="white-space: nowrap;" />');
                        $block.css({
                            overflow: 'hidden',
                            width:$block.css('width'),
                            height:$block.css('height')
                        }).addClass('transforming');
                        var $inner = $block.find('.inner');
                        $inner.addClass('inline-block').css('visibility', 'hidden').html(resp);

                        window.setTimeout(function(){
                            var diff = $inner.height() - $block.height();

                            $block.animate({
                                width: $inner.width()+'px',
                                height: $inner.height()+'px',
                                top: (parseInt($block.css('top')) - ($block.data('position')=='top'? diff : 0)) + 'px'
                            }, 100,function(){
                                $inner.css('visibility', 'visible');
                                $block.removeClass('transforming').css({
                                    overflow: 'visible'
                                });
                                $block.animate({opacity : 1}, 100);
                            });
                        }, 100)

                    }, false);

                    $(obj).data('xhr', xhr);
                }
            };
            $(popupDetailsMng.field).live('mouseenter click', function(){
                $(this).css({cursor: 'pointer'});
                popupDetailsMng.clearHideTimeout(this);
                if (!$(this).attr('data-id')){
                    return false;
                }
                if ($('.rating_details[data-item="'+$(this).closest('.cm, .item').attr('id')+'"]:visible').size()>0){
                    return false;
                }

                var obj = this;

                popupDetailsMng.clearLoadTimeout(this);
                var t = setTimeout(function(){
                    popupDetailsMng.loadDetailForm(obj);
                }, 200);
                $(this).data('timeout', t);
            });
            $(popupDetailsMng.field).live('mouseleave', function(){
                popupDetailsMng.clearHideTimeout(this);
                popupDetailsMng.clearLoadTimeout(this);

                var _this = this;
                var t = setTimeout(function(){
                    if ($(_this).data('xhr')){
                        $(_this).data('xhr').abort();
                    }
                    popupDetailsMng.hideDetailsBlocks(_this);
                }, 300);
                $(this).data('hide_timeout', t);
            });
        },

        trySetVote : function(action_url, id, vote, $item, extra){

            var defaults_options = {
                vote_block_sel: '.pst_menu',
                animate_remove: false,
                use_common_popup_container: false,
                popup_container: '',
                item_class_sel: '',
                use_comment: 1
            }

            this.options = $.extend({}, defaults_options, extra);

            this.action_url = action_url;
            this.ajax_status = null;
            this.id = id;
            this.item_jq_obj = $item;

            if (vote==0){
                this.tryShowDislikeReasonForm();
            }else{
                this.sendVote(vote, {});
            }
        },

        sendVote : function(vote, options){
            var _this=this;
            if (this.ajax_status=='idle'){
                return false;
            }

            this.ajax_status = 'idle';

            var $buttonVote = null;
            if (vote==0){

                var $buttonVote =
                    this.options.use_common_popup_container
                        ? $(this.options.popup_container).find(_this.popup_sel+'[data-item="'+_this.id+'"]').find('button')
                        : this.item_jq_obj.siblings(this.popup_sel).find('button');

                buttonIdleSwitch($buttonVote, true);
            }else{
                $buttonVote = this.item_jq_obj.find(this.options.vote_block_sel + ' .like');
                buttonIdleSwitch($buttonVote, true, {bg_img: true});
            }

            $.ajPost(this.action_url+'/'+this.id+'/'+vote, options, function(res){
                _this.ajax_status = null;

                buttonIdleSwitch($buttonVote, false, {bg_img: (vote==0 ? false : true)});

                if (_this.item_jq_obj.is('.cm') && _this.item_jq_obj.closest('.tape').size()==0){
                    refreshTapeCmRate(_this.id, res, vote);
                }else{
                    refreshRate(_this.item_jq_obj.find(_this.options.vote_block_sel+' .rating'), res);
                }

                var $voteButtons = _this.item_jq_obj.find(_this.options.vote_block_sel).find('.like, .dislike');

                if (_this.options.animate_remove && !app.responsive_mode){
                    $voteButtons.animate({width:'toggle'}, 'fast', function(){
                        $(this).remove();
                    });
                }else{
                    $voteButtons.remove();
                }

                if (vote==0){
                    _this.hideDislikeReasonForm();
                }
                app.checkForStatusNotice('vote');
            }, false, "json");
        },

        tryShowDislikeReasonForm	: function(){
            var _this=this;
            var $popup =
                this.options.use_common_popup_container
                    ? $(this.options.popup_container).find(_this.popup_sel+'[data-item="'+_this.id+'"]')
                    : this.item_jq_obj.siblings(_this.popup_sel+'[data-item="'+_this.id+'"]');

            if ($popup.size()>0){
                _this.showDislikeReasonForm();
                return true;
            }
            $(_this.popup_sel).remove();
            var $dislike_button = _this.item_jq_obj.find(_this.options.vote_block_sel+' a.dislike');

            buttonIdleSwitch($dislike_button, true, {bg_img: true});
			if (app.responsive_mode){
				var control_id = 'control_'+generateRandomId();
				$dislike_button.attr('data-control_id', control_id);
				commonOperations.shomPopupWindowPage('/menu/vote_reason_form', {
					post_params: 'use_comment='+_this.options['use_comment']+'&action_url='+encodeURIComponent(this.action_url+'/'+this.id+'/0')+'&item_id='+this.id+'&control_id='+control_id,
					callbacks : {
						close: function($win){
							if ($dislike_button.data('form_res')){
								if (_this.item_jq_obj.is('.cm') && _this.item_jq_obj.closest('.tape').size()==0){
									refreshTapeCmRate(_this.id, $dislike_button.data('form_res'));
								}else{
									refreshRate(_this.item_jq_obj.find(_this.options.vote_block_sel+' .rating'), $dislike_button.data('form_res'));
								}

								var $voteButtons = _this.item_jq_obj.find(_this.options.vote_block_sel).find('.like, .dislike');
								$voteButtons.remove();

							}
						}
					}
				});
				buttonIdleSwitch($dislike_button, false, {bg_img: true});
			}else{
				$.ajPost('/menu/vote_reason_form', {use_comment : _this.options['use_comment']}, function(resp){
					var $div=$(resp);

					var offset = {};
					var position = 'absolute';

					offset = {
						top : ($dislike_button.offset()).top + 25 - _this.item_jq_obj.offsetParent().offset().top,
						left: ($dislike_button.offset()).left - 20 - _this.item_jq_obj.offsetParent().offset().left
					}

					var left_position = ($dislike_button.offset()).left;
					if (left_position+320 > $(window).width()){
						var delta = left_position+320 - $(window).width();
						offset.left -= (delta+50);
						$div.css('backgroundPosition', (28+delta+50) + 'px -168px');
					}


					$div.css(
						{top : offset.top, left: offset.left, position: position}
					);

					if (_this.options.use_common_popup_container){
						$(_this.options.popup_container).append($div);
					}else{
						_this.item_jq_obj.after($div);
					}

					if (_this.item_jq_obj.parents('.cm_chat').size()>0){
						$div.find('.labelBlock').hide();
					}

					$div.attr('data-item', _this.id);

					_this.showDislikeReasonForm();
					buttonIdleSwitch($dislike_button, false, {bg_img: true});
				}, false);
			}
        },

        bindPopupClose	: function(){
            var _this=this;
            $('body').live('click.popup', function(event){
                if ($(event.target).parents(_this.popup_sel).size()==0 && !$(event.target).is($(_this.popup_sel)) && !$(event.target).is(_this.item_jq_obj.find('a.dislike'))){
                    _this.hideDislikeReasonForm();
                }
            });
        },

        showDislikeReasonForm : function(){
            var _this=this;

            var $popup =
                this.options.use_common_popup_container
                    ? $(this.options.popup_container).find(_this.popup_sel)
                    : this.item_jq_obj.siblings(this.popup_sel);

            $popup.fadeIn(function(){
                $(this).find('.text').focus();

                $(this).find('.text').bind('change keyup paste cut', function(){
                    var $input=$(this);
                    var $btn=$(_this.popup_sel).find('button');
                    setTimeout(function(){
                        if($input.val().trim()!=''){
                            $btn.removeClass('button4_dis');
                        } else {
                            $btn.addClass('button4_dis');
                        }
                    }, 100);
                });

                $(this).find('form').submit(function(){
                    var $input=$(this).find('.text');
                    if ($input.val().trim()!=''){
                        var params = $(this).serializeArray();
                        var options = {};
                        $.each(params, function(i){
                            options[params[i]['name']] = params[i]['value'];
                        });
                        _this.sendVote(0, options);
                    }
                    return false;
                });

                _this.bindPopupClose();
            });
        },

        hideDislikeReasonForm : function(){
            var $popup =
                this.options.use_common_popup_container
                    ? $(this.options.popup_container).find(this.popup_sel)
                    : this.item_jq_obj.siblings(this.popup_sel);
            $popup.fadeOut('fast');
            $('body').die('click.popup');
        }
    }
    var objMng = new _objMng();
    return objMng;
}

var voteOperations = new voteOperationsClass();

autoloadMng = {
	params : {},
	constants : {
		CHECK_MODE : 1,
		DRAW_MODE : 2
	},
	data : {},
	bindAutoload : function(options){
		var _this = this;

		var default_params = {
			$node : null,
			getItemsUrl: '',
			onLoadItems: function(data){},
			checkInterval: 10000,
			checkNew: true,
			data	: {}
		}

		this.params = $.extend({}, default_params, options);
		this.data = this.params.data;

		$(document).unbind('scroll').bind('scroll', function(){
			if (isBottom()){
				_this.loadItems(false);
			}
		});

		if (($('#container').height()-50) < $(window).height()){
			_this.loadItems(false);
		}

		_this.setCheckingForNew();
	},

	loadItems : function(callback){
		var _this = this;
		var params = this.params;
		var $block = params.$node;

		if(!$block.hasClass('idle') && !$block.hasClass('completed')){

			var loaded = $block.find('.item').size();
			var offset = _this.data.offset;

			if (loaded<offset){
				return false;
			}

			$block.addClass('idle');
			$block.addClass('completed');

			var post_params = 'ajx=1';

			$.each(_this.data, function(name, value){
				post_params = post_params +"&"+name+"="+value;
			});

			var limit = _this.data.limit;

			var $tmp=$('<div class="block_progress"></div>').css({
				height:'50px'
			});
			$block.after($tmp);


			var xhr = $.ajPost(params.getItemsUrl, post_params, function(resp){
				if (!resp.success){
					return false;
				}else{
                    if (resp.count==0 && resp.offset==0){
                        $tmp.remove();
                    }else{
                        $tmp.fadeOut(function(){$(this).remove();});
                    }


					if (resp.count == limit && resp.count>0){
						$block.removeClass('completed');
					}
					if (resp.count>0 || (resp.count==0 && resp.offset==0)){
						var $newData = $(resp.html).hide();
						$block.append($newData);
						$newData.fadeIn();

						_this.data.limit = resp.limit;
						_this.data.offset = resp.limit+resp.offset;

						params.onLoadItems($newData);
						if (callback){
							callback();
						}
					}
				}
				$block.removeClass('idle');
			}, false, 'json');

            $block.data('xhr', xhr);
		}
	},

	checkUpdates	: function(mode, offset_correction){
		var _this = this;
		var params = _this.params;
		var $block = params.$node;

		if (!offset_correction){
			offset_correction = 0;
		}

        if ($block.hasClass('idle')){
            return false;
        }

		$block.addClass('idle');
		var form_val = {
			offset: _this.data.offset,
			limit: _this.data.limit
		}

		_this.data.offset = 0;
		_this.data.limit = $block.find('.item').size()+offset_correction;

		var post_params = 'ajx=1';

		$.each(_this.data, function(name, value){
			post_params = post_params +"&"+name+"="+value;
		});

		if (mode==_this.constants.CHECK_MODE){
			post_params += "&new=1";
		}

		$.ajPost(params.getItemsUrl, post_params, function(resp){
			_this.data.offset = form_val.offset;
			_this.data.limit = form_val.limit;

			$block.removeClass('idle');

			if (!resp.success){
				return false;
			}else{
				if (resp.count>0){
					_this.data.offset = resp.count;
					if (mode == _this.constants.CHECK_MODE){
						var wasUpdatedData = _this.itemsHasUpdated(resp.items);
						if (wasUpdatedData['is_diff']){
							_this.checkUpdates(_this.constants.DRAW_MODE, wasUpdatedData['_new']-wasUpdatedData['_delete']);
						}
					}else if (mode==_this.constants.DRAW_MODE){                        
						_this.refreshItems(resp.html);
					}			
				}
			}
		}, false, 'json');
	},

	itemsHasUpdated : function(new_items){
		var result = {
			is_diff : false,
			_new: 0,
			_delete: 0
		}
		var showed_items = [];

		var $block = this.params.$node;

		$block.find('.item').each(function(i){
			showed_items[i] = $(this).attr('rel');
		});

		var new_items_str = new_items.join(',');
		var showed_items_str = showed_items.join(',');
		for (var index in showed_items){
			if (!(new_items_str.indexOf(showed_items[index])>=0)){
				result.is_diff = true;
				result._delete += 1;
			}
		}


		for (var index in new_items){
			if (!(showed_items_str.indexOf(new_items[index])>=0)){
				result.is_diff = true;
				result._new += 1;
			}
		}

		result._delete = result._new - result._delete;

		return result;
	},

	refreshItems	: function(new_html){
		var _this = this;
		var $newData = $('<div></div>').html(new_html);

		var $block = this.params.$node;

		$block.find('.item').each(function(i){
			if ($newData.find('[rel="'+$(this).attr('rel')+'"]').size()==0){
				$(this).fadeOut(function(){
                    $(this).remove();
                    _this.correctEvenOddItemsOrder();
                });
			}
		});

		$newData.find('.item').each(function(i){
            var $oldItem = $block.find('[rel="'+$(this).attr('rel')+'"]');
            var $newItem = $(this);
			if ($oldItem.size()==0){
				$block.prepend($newItem.hide());
                $newItem.slideIn(1000);
                _this.correctEvenOddItemsOrder();
				_this.params.onLoadItems($newItem);
			}else{                
                var iclass = 'restricted';
                var is_new_has = $newItem.hasClass(iclass);
                var is_old_has = $oldItem.hasClass(iclass);
                var new_status = is_new_has ? $newItem.find('.moder .status').data('restrict_type') : null;
                var old_status = is_old_has ? $oldItem.find('.moder .status').data('restrict_type') : null;

                if ((is_new_has&&!is_old_has) || (!is_new_has&&is_old_has) || (is_new_has&&is_old_has&&(new_status!=old_status))){
                    $oldItem.before($newItem.hide());
                    $oldItem.fadeOut(function(){
                        $(this).remove();
                        $newItem.fadeIn();
                        _this.correctEvenOddItemsOrder();
                    });

                    _this.params.onLoadItems($newItem);
                }
			}
		});

	},

    correctEvenOddItemsOrder : function(){
        var $block = this.params.$node;

        if ($block.find('.item').closest('.items_line').size()!=0){
            return;
        }
        
        $block.find('.item').each(function(i){
            $(this).removeClass('item_even').removeClass('item_odd').addClass((i+1)%2!=0 ? 'item_odd' : 'item_even');
        });
    },

	checkingIntervals	: {},
	checkNew : true,
	setCheckingForNew	: function(){
		var _this = this;
		var params = _this.params;

		if (!this.checkNew || !params.checkNew){
			return false;
		}

		this.checkingIntervals[params.$node.attr('id')] = window.setInterval(function(){
			if (params.$node.size()==0 || !params.$node.is(':visible')){
				if (_this.checkingIntervals[params.$node.attr('id')]){
					_this.clearNewCheckingInterval();
					return false;
				}
			}
			if(!params.$node.hasClass('idle')){
				_this.checkUpdates(_this.constants.CHECK_MODE, false);
			}
		}, params.checkInterval)
	},

	clearNewCheckingInterval: function(){
		window.clearInterval(this.checkingIntervals[this.params.$node.attr('id')]);
	}
}

scrollNavigation={
	options : {
		navElementClass : 'navigationElement',
		containerSelector : '#page_area',
		defaultBottomValue : 20
	},
	langs : {
		'user::scroll_up' : null,
		'user::scroll_down' : null
	},
	states : {
		HIDDEN : 0,
		VISIBLE_DOWN : 1,
		VISIBLE_UP : 2
	},
	state: 0,
	navElement : null,
	init: function(options){
		if (options){
			this.options = $.extend({}, this.options, options);
		}

		var _this = this;
		this.off();
		this.loadLang(function(){
			$(window).unbind('scroll.navscroll').bind('scroll.navscroll', function(){_this.onScroll()});
			_this.onScroll();
		});
	},
	position: 0,
	onScroll : function(){
		var window_height = $(window).height();

		this.position = $(window).scrollTop();

		if (this.state==this.states.HIDDEN || this.state==this.states.VISIBLE_UP){
			if ($(window).scrollTop() > window_height*1.05){
				this.showNavigation(this.states.VISIBLE_UP);
			}
			if ($(window).scrollTop() < window_height){
				this.state = this.states.HIDDEN;
				this.hideNavigation();
			}
		}else if (this.state==this.states.VISIBLE_DOWN){
			if ($(window).scrollTop() > 100){
				this.showNavigation(this.states.HIDDEN);
			}
		}
	},
	showNavigation : function(state){
		var _this = this;
		var $navEl = !this.navigationElementExist() ? this.createNavigationElement() : this.navElement;
		if ($navEl.hasClass('scroll_idle')){
			return false;
		}

		this.state = state;

		var diff = $(window).scrollTop()+$(window).height() - $(this.options.containerSelector).height();

		if (diff>this.options.defaultBottomValue){
            $navEl.data('bottom-shift', diff-this.options.defaultBottomValue);            
			$navEl.css({bottom: diff+'px'});
			this.setNavElementPositionChecker();
		}else{
            var shift = 0;

            if ($navEl.data('bottom-shift')){
                shift = $navEl.data('bottom-shift');
            }

			$navEl.css({bottom: (this.options.defaultBottomValue+shift)+'px'});
		}

		if ($navEl.data('state')==state && $navEl.is(':visible')){
			return false;
		}

		$navEl.data('state', state);

		$navEl.find('.arrow').removeClass('arrow_down arrow_up').addClass('arrow_'+(state==_this.states.VISIBLE_UP ? 'up' : 'down'));
		if (!$navEl.is(':visible')){
			$navEl.fadeIn();
		}


		switch (state){
			case this.states.VISIBLE_UP:
				$navEl.attr('title', this.langs['user::scroll_up']).off('click').on('click', function(){
					$(this).data('return_position', $(window).scrollTop()-($navEl.data('bottom-shift') ? $navEl.data('bottom-shift') : 0));

					$navEl.addClass('scroll_idle');
					_this.setScrollPosition(0, function(){
						$navEl.removeClass('scroll_idle');
						_this.showNavigation(_this.states.VISIBLE_DOWN);

                        if ($navEl.data('bottom-shift')){
                            $navEl.animate({bottom: _this.options.defaultBottomValue+'px'});
                            $navEl.data('bottom-shift', 0);
                        }
					});
				});
				break;
			case this.states.VISIBLE_DOWN:
				$navEl.attr('title', this.langs['user::scroll_down']).off('click').on('click', function(){

					$navEl.addClass('scroll_idle');

					_this.setScrollPosition($(this).data('return_position'), function(){
						$navEl.removeClass('scroll_idle');
						_this.showNavigation(_this.states.VISIBLE_UP);
					});
				});
				break;
		}
	},

	setNavElementPositionChecker : function(){
		var _this = this;

		var TIMEOUT = 200;
		var CHECKING_DURATION = 3000;

		var duration = 0;
        if (this.navElement==null){
            return false;
        }

		if (this.navElement.data('intervalH')){
			window.clearInterval(_this.navElement.data('intervalH'));
		}
		var interval = window.setInterval(function(){
			if (duration>=CHECKING_DURATION){
				window.clearInterval(_this.navElement.data('intervalH'));
				return false;
			}

			var diff = $(window).scrollTop()+$(window).height() - $(_this.options.containerSelector).height();

			if (diff<=_this.options.defaultBottomValue){
				_this.navElement.animate({bottom: _this.options.defaultBottomValue+'px'});
                _this.navElement.data('bottom-shift', 0);
				window.clearInterval(_this.navElement.data('intervalH'));
				return false;
			}

			duration += TIMEOUT;
		}, 200);

		this.navElement.data('intervalH', interval);
	},

	setScrollPosition	: function(position, callback){
		$('html, body').animate({scrollTop : position}, function(){
			if (callback){
				callback();
			}
		});
		this.position = position;
	},
	hideNavigation : function(){
		if (this.navElement!=null){
			if (this.navElement.hasClass('scroll_idle')){
				return false;
			}
			this.navElement.fadeOut('slow');
		}
	},
	navigationElementExist : function(){
		return ($('.'+this.options.navElementClass).size()>0);
	},
	createNavigationElement : function(){
		var $div = $('<div></div>').addClass(this.options.navElementClass);
		var $arrow = $('<div></div>').addClass('arrow');
		$div.hide().append($arrow).appendTo($(this.options.containerSelector));

		this.navElement = $div;

		return $div;
	},
	loadLang : function(callback){
		var _this = this;
		var keys = [];
		for (var i in this.langs){
			if (this.langs[i]!=null){
				if (callback){
					callback();
				}
				return;
			}
			keys.push(i);
		}
		$.ajPost(app.host + '/menu/get_langs', {keys: keys}, function(resp){
			for (var i in resp){
				_this.langs[i] = resp[i];
			}
			if (callback){
				callback();
			}
		}, false, 'json');
	},
	off: function(){		
		$('.'+this.options.navElementClass).remove();
        if (this.navElement && this.navElement.data('intervalH')){
            window.clearInterval(this.navElement.data('intervalH'));
        }
		this.navElement = null;
		this.state = this.states.HIDDEN;
		$(window).unbind('scroll.navscroll');        
	}
}

isBottom=function(){
	return ($(document).scrollTop()+$(window).height())>($(document).height()-400);
}

isBottomAtContainer=function($container, correct_position_value){
	if ($container.size()==0){
		return false;
	}
	if (!correct_position_value){
		correct_position_value = 0;
	}
	var container_bottom = $container.position().top+$container.height();
	return ($(document).scrollTop()+$(window).height()+correct_position_value)>(container_bottom);
}

check_empty=function(input){
	var value=input.value.replaceAll('<p>', '').replaceAll('</p>', '').replaceAll('</p>', '').replaceAll('<br>', '').replaceAll('\n', '').trim();
	var def=$(input).attr('default');
	
	if(value=='') return true;
	if(def && value==def.trim()) return true;
	
	return false;
}

onInputFocus=function(e){
	var $input=$(this).find('input');
	var $this=$(this);
	if($input.length==0) $input=$this;
	
	if($input.val().trim()==$this.attr('default').trim()){
		$input.val('');
		$this.removeClass('inp_inactiv');
	}
}

onInputBlur=function(e){
	var $input=$(this).find('input');
	var $this=$(this);
	if($input.length==0) $input=$(this);

	if($input.val().trim()==''){
		$input.val($this.attr('default'));
		$this.addClass('inp_inactiv');
	}
}

swapOut=function($node1, $node2, duration, colClass, $scroll, fnc){
	var parW=$node1.width();
	var parOH=$node1.outerHeight(true);
	var swapH=$node2.height();
	
	if($scroll){
		var maxH=parseInt($scroll.css('maxHeight'), 10);
		var msglH=$scroll.find('.jspPane').outerHeight();
		var sAnimateH=msglH-parOH+swapH;
		if(sAnimateH>maxH) sAnimateH=maxH;

		$scroll.find('.jspContainer').animate({height:Math.min(sAnimateH, maxH)}, {duration:duration, queue:false, complete:function(){
			$scroll.data('jsp').reinitialise();
		}});
	}

	if (!$node1.hasClass('level')){
		$node1.css({margin:0})
	}

	$node1
		.css({height:parOH+'px'})
		.addClass(colClass)
		.animate({height:swapH}, {queue:false, duration:duration})
		.fadeOut(duration, function(){
			$node2.css('position', '');
			$node1.css({width:parW+'px', position:'absolute', visibility:'hidden', display:'block'});
			if(fnc) fnc();
		});

	$node2
		.css({width:parW+'px', visibility:'', display:'none'})
		.fadeIn(duration);
		
	$node1.attr('paroh', parOH);
}

swapIn=function($node1, $node2, duration, colClass, $scroll, fnc){
	var parOH=$node1.attr('paroh');
	
	if($scroll){
		var maxH=parseInt($scroll.css('maxHeight'), 10);
		var msglH=$scroll.find('.jspPane').outerHeight();
		var sAnimateH=msglH+(parOH-$node1.height());
		if(sAnimateH>maxH) sAnimateH=maxH;

		$scroll.find('.jspContainer').animate({height:Math.min(sAnimateH, maxH)}, {duration:duration, queue:false, complete:function(){
			$scroll.data('jsp').reinitialise();
		}});
	}

	$node2.css('position', 'absolute').fadeOut(duration, function(){
		$node2.remove();
	});
	
	$node1.removeClass(colClass)
		.css({position:'', visibility:'', display:'none'})
		.animate({height:parOH}, {queue:false, duration:duration, complete:function(){
			$(this).css({'height':'', 'margin':'', 'width':'', 'display':''});
			if(fnc) fnc();
		}})
		.fadeIn(duration);
}

swapBlocks=function($node1, $node2, duration, callback, horizontal){
	var $visible=$node1.is(':hidden') ? $node2 : $node1;
	var $hidden=$node1.is(':hidden') ? $node1 : $node2;
	
	if((!$visible || $visible.length==0) && (!$hidden || $hidden.length==0)) return false;
	
	//Animate elements
	if($visible){
		var vopts={opacity:0};
		if(horizontal) $.extend(vopts, true, {width:0, paddingLeft:0, paddingRight:0, marginLeft:0, marginRight:0});
			else  $.extend(vopts, true, {height:0, paddingTop:0, paddingBottom:0, marginTop:0, marginBottom:0});

		$visible.animate(vopts, {duration:duration, complete:function(){
			$(this).css({display:'none', opacity:'', height:'', width:'', paddingTop:'', paddingBottom:'', marginTop:'', marginBottom:''})
			$(this).css({paddingLeft:'', paddingRight:'', marginLeft:'', marginRight:''});
			if (!$hidden && typeof(callback)=="function") callback();
		}});
	}

	if($hidden){
		//Grab hidden data
		if(horizontal) var params=['width', 'paddingLeft', 'paddingRight', 'marginLeft', 'marginRight'];
			else var params=['height', 'paddingTop', 'paddingBottom', 'marginTop', 'marginBottom'];

		var hdata={};
		$hidden.css({position:'absolute', visiblity:'hidden', display:'block'});
		$.each(params, function(i, key){
			if(key=='height') hdata[key]=$hidden.height();
			else if(key=='width') hdata[key]=$hidden.width();
			else hdata[key]=$hidden.css(key);
		});
	
		if(horizontal){
			var hopts={width:hdata.width, paddingLeft:hdata.paddingLeft, paddingRight:hdata.paddingRight, marginLeft:hdata.marginLeft, marginRight:hdata.marginRight};
		} else {
			var hopts={height:hdata.height, paddingTop:hdata.paddingTop, paddingBottom:hdata.paddingBottom, marginTop:hdata.marginTop, marginBottom:hdata.marginBottom};
		}

		var css_opts={position:'', visiblity:'', display:'block'};
		if(horizontal) $.extend(css_opts, true, {width:'0px', paddingLeft:'0px', paddingRight:'0px', marginLeft:'0px', marginRight:'0px'});
			else $.extend(css_opts, true, {height:'0px', paddingTop:'0px', paddingBottom:'0px', marginTop:'0px', marginBottom:'0px'});

		$hidden
			.css(css_opts)
			.animate(hopts, {duration:duration, complete:function(){
				$(this).css({height:'', width:''})
				$(this).css({paddingTop:'', paddingBottom:'', marginTop:'', marginBottom:''});
				$(this).css({paddingLeft:'', paddingRight:'', marginLeft:'', marginRight:''});
				if (typeof(callback)=="function") callback();
			}});
	}
}

showFormError=function($node, error, noHide, effectType){
	$node.find('.err_text').show().html(error);

	if($node.is(':hidden')){
		if(effectType=='no') $node.css({display:'block'});
		else if(effectType=='slide') $node.slideIn('fast');
		else $node.fadeIn('fast');
	}
	
	var hide_func=function(){
		if(effectType=='no') $node.css({display:'none'});
		else if(effectType=='slide') $node.slideUp('fast');
		else $node.fadeOut('fast');
	}
	
	if(!noHide) setTimeout(hide_func, 2000);
	$node.unbind('click').bind('click', hide_func);
}

function flash_message(message, player_id, clip_id){
	$('#'+player_id).trigger('custom', arguments);
}

function FlplayerCall(flp_id, fnc){
	var objNode=(navigator.appName.indexOf("Microsoft") != -1)?window[flp_id]:document[flp_id];
    if(objNode) objNode.SetVariable("func_id", fnc);    
}

function generateRandomId(){
	return ("" + Math.random()).slice(10);
}

function genUniqUploadId(){
	return generateRandomId();
}

//Drag functions
dragClear=function(){
	if(drag_tm){
		clearTimeout(drag_tm);
		drag_tm=false;
	}
	leftButtonDown=0;	
}

dragCalcBoundies=function(boundies, $node, node_id, leftOffset){
	var noffset=$node.offset();
	if(leftOffset>0) noffset.left=noffset.left-leftOffset;
	
	var nW=$node.outerWidth(true);
	var nH=$node.outerHeight(true);
	var bound={lt:[noffset.left, noffset.top], rt:[noffset.left+nW, noffset.top], lb:[noffset.left, noffset.top+nH], rb:[noffset.left+nW, noffset.top+nH]};
	
	var chk_points=bound;
	if(nW>apprx || nH>apprx){
		//Add additional points
		var tmpY=noffset.top;
		var i=0;
		while(true){
			var tmpX=noffset.left;
			while(tmpX<(noffset.left+nW)){
				i++;
				chk_points['tmp'+i]=[tmpX, tmpY];
				tmpX+=apprx;
			}
			
			tmpY+=apprx;
			if(tmpY>(noffset.top+nH)) break;
		}
	}

	$.each(chk_points, function(key, point){
		var xN=Math.floor(point[0]/apprx);
		var yN=Math.floor(point[1]/apprx);
		
		if(!boundies[xN]) boundies[xN]={};
		if(!boundies[xN][yN]) boundies[xN][yN]={};
		if(!boundies[xN][yN][node_id]){
			boundies[xN][yN][node_id]={elem:$node, bound:bound};
		}
	})
}

//Debug functions

if (typeof(console) == 'undefined') console = {log:function(){}, error:function(){}};

app_log=function(data, sli_group_type, reinit){
	if(sli_group_type && (!window[sli_group_type] || reinit)) window[sli_group_type]=parseInt(Math.random()*1000000, 10);
	var sli_group=window[sli_group_type]?window[sli_group_type]:0;
	
	$.ajax({
	    type:'POST',
	    url:app.host+'/log',
	    data:{
	    	sli_group:sli_group,
	    	data:data
	   	},
	    async:false
	});
}

function html_truncate(text, length, suffix){
	var simpleTags=['br','hr','input','image','link','meta'];
	var offset=tlen=tagc_len=completed=stop_pos=0;
	var output=tail=ending='';
	var stack=[], tags=[];
	
	//Prepare text
	text=str_replace(['<p>', '</p>'], ['', '<br>'], text);
	
	var regexp=/<[^>]+>/g;
	while (o = regexp.exec(text)) {
		var lastIndex=regexp.lastIndex;
	    var b=text.substring(offset, lastIndex-o[0].length);
		var blen=b.length;
		offset=regexp.lastIndex;
		
		if (blen>0){
			if (stack.length==0){
				if ((tlen+blen)>length){
					ending=b.substring(0, length-tlen);
					output+=ending;
					tlen+=ending.length;
					stop_pos=lastIndex-blen+ending.length-o[0].length;
					completed=1;
					break;
				} else {
					output+=b;
					tlen+=blen;
				}
			} else {
				if ((tlen+tagc_len+blen)>length){
					//Close current tags and reopen for tail
					var close=[];
					$(stack).each(function(i, sub){
						if (sub[0]=='tag'){
							if(sub[3]=='open') close.push("</"+sub[2]+">");
							else close.pop();
						}
						output+=sub[1];
					});
					ending=b.substring(0, length-(tlen+tagc_len));
					output+=ending;
					tlen+=ending.length;
					stop_pos=lastIndex-blen+ending.length-o[0].length;
					completed=1;
					output+=close.join('');
					break;
				} else {
					stack[stack.length]=['text', b];
					tagc_len+=blen;
				}
			}
		}
		
		if (o[0][1]=='/'){
			var tag=strtok(o[0], " \t\n\r\0\x0B>").substring(2).toLowerCase();
			
			if (array_has(simpleTags, tag)){
				if (stack.length==0){
					output+=o[0];
				} else {
					stack[stack.length]=['text', o[0]];
				}
			} else if(array_has(tags, tag)){
				if (tags[tags.length-1]==tag){
					stack[stack.length]=['tag', o[0], tag, 'close'];
					tags.pop();
				} else {
					//Auto stack correction
					while (true){
						var scan=tags.pop();
						if (scan==tag) break;
						
						for (var i=stack.length-1; i>=0; i--){
							if (stack[i][0]=='tag' && stack[i][2]==scan){
								stack[i]=['text', ''];
								break;
							}
						}
					}
					stack.push(['tag', o[0], tag, 'close']);
				}
				
				if (tags.length==0){
					if ((tlen+tagc_len)<=length){
						$(stack).each(function(i, sub){ output+=sub[1]; })
						tlen+=tagc_len;
						stack=[];
					} else {
						console.error('Parse bug!');
					}
				}
			}
		} else {
			var tag=strtok(o[0], " \t\n\r\0\x0B>").substring(1).toLowerCase();
			if (stack.length==0) tagc_len=0;
			
			if (array_has(simpleTags, tag)){
				if (stack.length==0){
					output+=o[0];
				} else {
					stack.push(['text', o[0]]);
				}
			} else {
				stack.push(['tag', o[0], tag, 'open']);
				tags.push(tag);
			}
		}
	}

	//Check tail
	b=text.substring(offset);
	if (stack.length==0 && !completed){
		blen=b.length;
		if (blen>0 && tlen<length){
			if (blen<(length-tlen)){
				output+=b;
				tlen+=blen;
				stop_pos=text.length;
			} else {
				ending=b.substring(0, length-tlen);
				output+=ending;
				stop_pos=offset+ending.length;
				tlen+=ending.length;
			}
		} else stop_pos=text.length;
	}
	
	if (suffix && output!=text) output+=suffix;
	
	//Create tail
	if (stop_pos>0){
		if (stack.length>0){
			$(stack).each(function(i, sub){
				if (sub[0]=='tag') tail+=sub[1];
			});
		}
		tail+=text.substring(stop_pos);
	}
	
	return [output, tail];
}

requestTimeout = null;
savePagePosition=function($items, prefix, numpage){
    if (requestTimeout != null){
    	window.clearTimeout(requestTimeout);
    	requestTimeout = null;
    }

    requestTimeout = window.setTimeout(function(){
        var number = 0;
        $items.each(function(){
            if ($(this).offset().top - $(window).scrollTop() > $(window).height()){
                return false;
            }else{
                number++;
            }
        });

        $(document.body).css({backgroundImage:(number>40 ? 'none' : '')});

        var page = Math.ceil(number/numpage)*numpage;
        setCookie(prefix+'_nm', page, null);
        setCookie(prefix+'_scrpos', $(window).scrollTop());
    }, 500);
}

imagesMng = {
	bindTypes	: {
		UNBIND_BIND : 1,
		LIVE : 2
	},
	params	: {},
	init	: function(options){
		var default_params = {
			root_id: '',
			sel: '',
			autoshow: 0,
			get_url_func: null,
			bind_type: this.bindTypes.LIVE,
			uniq_id_attr: 'id'
		}

		this.params = $.extend({}, default_params, options);

		if (this.params.sel!=''){
			this.bindShowOnClick();
		}
	},
	bindShowOnClick	: function(){
		var _this = this;
		var onClick = function(e, href){
			if(mlClick(e)){
				var photo_id=$(href).attr(_this.params.uniq_id_attr).replace('pimg_', '');
				/*app.set_url(_this.params.get_url_func!=null ? _this.params.get_url_func(photo_id) : $(href).attr('href'));*/
				commonOperations.showImgGallery($(href));

				return false;
			}
		}
		if (this.params.bind_type == this.bindTypes.UNBIND_BIND){
			$('#'+this.params.root_id).find(this.params.sel).unbind('click').bind('click', function(e){
				onClick(e, this);
				return false;
			});
		}else{
			$('#'+this.params.root_id).find(this.params.sel).live('click', function(e){
				onClick(e, this);
				return false;
			});
		}
	}
}

authReq=function(options){
	if(typeof(options)=='function') options={ onAuth:options };
	
	if(app.guest){
		var extra=options['post'] ? options['post'] : {};
        if (options.template){
            extra['template'] = options['template'];
        }
		
		$.ajPost(urlT('unauthorized', 'menu'), extra, function(resp){
			$('#auth_pop').html(resp);
			$('#unauth').data('options', options);
		}, false);
	} else {
		options.onAuth();
	}
}

commonOperations = {
	bindBaseActions: function(){
		$('body').on('click', '.popup_link', function(){
			var post_params = false;
			var $control = $(this);
			$control.trigger('prepare_post_data');
			if ($control.data('post_data')){
				post_params = $control.data('post_data');
			}
			var src = $(this).attr('href');
			if (!src){
				src = $(this).data('url');
			}
			commonOperations.shomPopupWindowPage(src, {
				modal: false,
				align: $(this).data('popup_align') ? $(this).data('popup_align') : 'default',
				bgclick_close_off: $(this).data('bgclick_close_off') ? $(this).data('bgclick_close_off')==1 : false,
				esc_key_close_off: $(this).data('esc_key_close_off') ? $(this).data('esc_key_close_off')==1 : false,
				extra_class: $(this).data('popup_class') ? $(this).data('popup_class') : '',
				post_params: post_params
			});
			return false;
		});

		$('body').on('click', '.popup_img', function(){
			commonOperations.showFullImage($(this).attr('href') ? $(this).attr('href') : $(this).attr('src'));
			return false;
		});

		$('body').on('click', '.popup_embed_video', function(){
			$.magnificPopup.open({
				items: [
					{src: $(this).attr('href')}
				],
				disableOn: 700,
				type: 'iframe',
				mainClass: 'mfp-fade mfp-video-iframe',
				removalDelay: 160,
				preloader: false,
				fixedContentPos: false,
				iframe:{
					patterns:{
						youtube2: {
							index: 'youtu.be/',
							id: function(url){
								var id = url.replace(/^(.+)?youtu\.be\//, "");
								id = id.replace(/(\?|&).*/, "");
								return id;
							},
							src: '//www.youtube.com/embed/%id%?autoplay=1'
						},
						youtube: {
							index: 'youtube.com/',
							id: function(url){
								if (url.indexOf('playlist')>-1){
									var id = url.replace(/^(.+)?youtube.com\/playlist\?list=/, "");
									id = id.replace(/(\?|&).*/, "");
									id = '//www.youtube.com/embed/?list_type=playlist&list='+id+'&autoplay=1'
								}else if(url.indexOf('?v=')>-1){
									var id = url.replace(/^(.+)?youtube\.com(.*?)\?v=/, "");
									id = id.replace(/(\?|&).*/, "");
									id = '//www.youtube.com/embed/'+id+'?autoplay=1'
								}else if(url.indexOf('/shorts/')>-1 || url.indexOf('/live/')>-1){
									var id = url.replace(/^(.+)?youtube\.com(.*?)\/(shorts|live)\//, "");
									id = '//www.youtube.com/embed/'+id+'?autoplay=1'
								}
								return id;
							},
							src: '%id%'
						},
						vimeo: {
							index: 'vimeo.com/',
							id: function(url){
								var id = url.replace(/^(.+)?vimeo\.com\//, "");
								id = id.replace(/(\?|&).*/, "");
								return id;
							},
							src: '//player.vimeo.com/video/%id%?autoplay=1'
						},
						vk: {
							index: 'vk.com/',
							id: function(url){
								var regexp = /vk.com\/video_ext\.php\?oid=([\w-]+)\&id=([\w-]+)&hash=([\w-]+)/g;
								var matches = regexp.exec(url);

								var id = "oid="+matches[1]+"&id="+matches[2]+"&hash="+matches[3];
								return id;
							},
							src: '//vk.com/video_ext.php?%id%&autoplay=1&hd=1'
						},
						ic: {
							index: app.host,
							id: function(url){
								if (url.indexOf('?')>-1){
									var id = url+'&autoplay=1';
								}else{
									var id = url+'?autoplay=1';
								}
								return id;
							},
							src: '%id%'
						}
					}
				}
			});

			return false;
		});

		$('body').on('click', '.modal_link', function(){
			commonOperations.shomPopupWindowPage($(this).attr('href'), {
				modal: true
			});
			return false;
		});

		$('body').on('click', '.common_action_link', function(){
			var $control = $(this);
			if ($control.hasClass('idle')){
				return false;
			}

			$control.siblings('.status_text:not(.common_status_text)').remove();
			$control.siblings('.common_status_text').attr('class', 'common_status_text').html('');

			if ($control.data('confirm')){
				if (!confirm($control.data('confirm'))){
					return false;
				}
			}
			app.switchIdle($control, true);

			var data = {};

			$control.trigger('prepare_post_data');
			if ($control.data('post_data')){
				data = $control.data('post_data');
			}else{
				if ($control.closest('.form_closure').size()){
					data = $control.closest('.form_closure').find(':input').serialize();
				}else if ($control.closest('form').size()){
					data = $control.closest('form').find(':input').serialize();
				}
			}

			if ($control.data('prompt')){
				$control.data('prompt', 0);
				data += '&prompt=1';
			}


			var action_url = $control.attr('href');
			if (!action_url){
				action_url = $control.data('url');
			}

			if (!action_url){
				if ($control.closest('.form_closure').size()){
					action_url = $control.closest('.form_closure').attr('action');
				}
			}



			var showSystemError = function(){
				var $status_text_field = $('<span>');
				if ($control.siblings('.common_status_text').size()>0){
					$status_text_field = $control.siblings('.common_status_text');
				}else{
					$control.after($status_text_field);
				}

				app.switchIdle($control, false);
				$status_text_field.addClass('status_text error').text('Ошибка при выполнении запроса');
			}

			$.ajax({
				url: action_url,
				type:'POST',
				data: data,
				dataType: 'json',
				success:function(resp){
					if (!resp){
						return showSystemError();
					}

					app.switchIdle($control, false);

					var success_callback = $control.data('success_callback');
					if (success_callback){
						if (typeof success_callback == 'function'){
							if (resp.success){
								success_callback($control, resp)
							}else{
								var $status_text_field = $('<span>');
								if ($control.siblings('.common_status_text').size()>0){
									$status_text_field = $control.siblings('.common_status_text');
								}else{
									$control.after($status_text_field);
								}

								$status_text_field.addClass('status_text error').html(resp.error);

								if ($status_text_field.find('.prompt_link').size()){
									$status_text_field.find('.prompt_link').on('click', function(){
										$control.data('prompt', 1);
										$control.trigger('click');
									})
								}
							}
						}else if (success_callback.indexOf('.')>0){
							var parts = success_callback.split('.');
							window[parts[0]][parts[1]]($control, resp);
						}else if (window[success_callback]){
							window[success_callback]($control, resp);
						}

						return;
					}

					if (resp.redirect){
						location.href = resp.redirect;
						return;
					}

					if (resp.data && resp.data.redirect){
						location.href = resp.data.redirect;
						return;
					}

					var $status_text_field = $('<span>');
					if ($control.siblings('.common_status_text').size()>0){
						$status_text_field = $control.siblings('.common_status_text');
					}else{
						$control.after($status_text_field);
					}

					if (!resp.success){
						var error_text;
						if (resp.error){
							error_text = resp.error;
						}else if (resp.errors){
							for (var field_name in resp.errors){
								for (var i in resp.errors[field_name]){
									error_text = resp.errors[field_name][i];
									break;
								}
								break;
							}
						}

						$status_text_field.addClass('status_text error').html(error_text);
					}else{
						if (!resp.text){
							resp.text = 'Изменения сохранены';
						}
						$status_text_field.addClass('status_text success').html(resp.text);
					}

					if ($status_text_field.find('.prompt_link').size()){
						$status_text_field.find('.prompt_link').on('click', function(){
							$control.data('prompt', 1);
							$control.trigger('click');
						})
					}

					$control.trigger('success_action', [resp]);
				},
				error:function(){
					showSystemError();
				}
			});

			return false;
		});

		$('body').on('mouseenter', '.tooltipster:not(.tooltipstered)', function(){
			var default_tooltipster_params = {
				animation: 'fade',
				side: 'top',
				theme: 'tooltipster-light',
				arrow: true,
				contentAsHTML: false,
				debug: false,
				updateAnimation: 'none',
				delay: 100
			};

			var tooltipster_params = default_tooltipster_params;

			var $control = $(this);
			var content_exist = false;
			if ($control.data('title_html')){
				tooltipster_params.contentAsHTML = true;
				tooltipster_params.interactive = 1;

				var content_exist = false;
				if ($control.next('.tooltip_html_content').size()>0){
					tooltipster_params.content = $control.next('.tooltip_html_content');
					content_exist = true;
				}else if($control.find('.tooltip_html_content').size()>0){
					tooltipster_params.content = $control.find('.tooltip_html_content');
					content_exist = true;
				}

			}else{
				tooltipster_params.content = $control.attr('title');
				tooltipster_params.contentAsHTML = false;
			}

			if ($control.data('tooltip_side')){
				tooltipster_params['side'] = $control.data('tooltip_side');
			}else{
				tooltipster_params['side'] = default_tooltipster_params['side'];
			}
			if ($control.data('tooltip_theme')){
				tooltipster_params['theme'] = 'tooltipster-'+$control.data('tooltip_theme');
			}else{
				tooltipster_params['theme'] = default_tooltipster_params['theme'];
			}

			if ($control.data('tooltip_delay')){
				tooltipster_params['delay'] = $control.data('tooltip_delay');
			}else{
				tooltipster_params['delay'] = default_tooltipster_params['delay'];
			}


			if ($control.data('tooltip_delay')){
				$control.on('mouseleave', function(){
					$control.data('leaved', 1);
				});
				window.setTimeout(function(){
					if (content_exist){
						tooltipster_params.content = tooltipster_params.content.html();
					}
					$control.tooltipster(tooltipster_params);

					if ($control.data('leaved')){
						return;
					}

					$control.tooltipster('open');
				}, $control.data('tooltip_delay'))
			}else{
				if (content_exist){
					tooltipster_params.content.show();
				}

				$control.tooltipster(tooltipster_params);

				$control.tooltipster('open');
			}
		});

		$('body').on('click', '.new_redactor  spoiler', function(){
			$(this).toggleClass('active');
		});

		$('body').on('click', 'fieldset.collapsable .legend', function(){
			var $fieldset = $(this).closest('fieldset');
			$fieldset.toggleClass('active');

			if ($fieldset.data('url_param_name')){
				var location_url = location.href;
				location_url = removeUrlParams(location_url, $fieldset.data('url_param_name'))
				if ($fieldset.hasClass('active')){
					var params = {};
					params[$fieldset.data('url_param_name')] = $fieldset.data('url_param_id');
					location_url = addUrlParams(location_url, params);
				}

				app.replace_url(location_url);
			}

			return false;
		});
	},
	clearTimeouts: function(obj, timeouts){
		for (var i in timeouts){
			if (typeof(timeouts[i])=='string' && $(obj).data(timeouts[i])){
				window.clearTimeout($(obj).data(timeouts[i]));
			}
		}
	},
	bindIconHover : function(params_in){
		var options = {};
		var default_options = {
			global_id: '',
			icon: 'td.icon a.qajx',
			hover_container: '.puinf',
			get_hover_info_block_fnc: null,
			timeout_ms: 150,
			timeout_ms_hide: 150
		};

		options = $.extend({}, default_options, params_in);
		var _this = this;

		$('#'+options.global_id).on('click', options.icon+' div.redirect_link', function(e){
			triggerUrlRedirect($(this).attr('href'), e);
			return false;
		});
		$('#'+options.global_id+' '+options.icon).live('mouseenter',
			function(){
				_this.clearTimeouts(this, ['show-tmout', 'hide-tmout']);

				var obj = this;
				var t = setTimeout(function(){
					var $container = $(obj).find(options.hover_container);

					if (options.get_hover_info_block_fnc!=null){
						$container = options.get_hover_info_block_fnc(obj);
					}
					$container.stop(true, true).fadeIn('fast');
				}, options.timeout_ms);

				$(this).data('show-tmout', t);
			}).live('mouseleave', function(){
				_this.clearTimeouts(this, ['show-tmout', 'hide-tmout']);

				var obj = this;
				var t = setTimeout(function(){
					var $container = $(obj).find(options.hover_container);

					if (options.get_hover_info_block_fnc!=null){
						$container = options.get_hover_info_block_fnc(obj);
					}
					$container.stop(true, true).fadeOut('fast');
				}, options.timeout_ms_hide);

				$(this).data('hide-tmout', t);
			});
	},

    showModalConfirm: function(text, button_text, on_ok, on_show, cancel_text, on_cancel){
        var _this = this;
        var loadData = function(){

            $('[rel="modal_window"]').find('.anpopup_user_content').html('<div class="content_wrapper"></div>');
            var $content_wrapper = $('[rel="modal_window"]').find('.anpopup_user_content .content_wrapper');
            $content_wrapper.append($('<div class="confirm_text"></div>').html(text));
            $content_wrapper.append($('<button></button>').attr({
                type: 'submit',
                class: 'button buttonCSS buttonCSS_1'
            }).text(typeof(button_text)=="undefined" ? "Да, уверен" : button_text).on('click', function(){
                    _this.closeAjModal();
                    if (on_ok){
                        on_ok();
                    }
					return false;
                }));

			if (cancel_text && cancel_text!=''){
				$content_wrapper.append($('<a></a>').attr({
					class: 'close_link link2 inherit'
				}).text(cancel_text).on('click', function(){
					_this.closeAjModal();
					if (on_cancel){
						on_cancel();
					}
					return false;
				}));
			}

            $.popup_display_modal( $('[rel="modal_window"]'), {
                init_pos:[$(window).width()/2, $(window).height()/2, false, 'center'],
                keep_on_close:true,
                on_hide: function(){
                    $('[rel="modal_window"]').find('.anpopup_user_content').html('');
                }
            });

            if (on_show){
                on_show();
            }
        }

        if ($('[rel="modal_window"]').size()==0){
            $.ajGet(
                urlT('get_modal_container', 'menu'),
                {},
                function(resp){
                    $('body').append($(resp));
                    loadData();
                },
                false
            );
        }else{
            loadData();
        }
    },

    ajGetToModal: function(url, data, callback, json, options){
        if (typeof(json)=="undefined"){
            json = true;
        }

		options = options || {};
		options.popup = options.popup || {};

        var modalWindowSelector = "[rel='modal_window']",
			loadData = function() {
            var onLoadHtml = function(html){
				var $modal = $(modalWindowSelector),
					$close = $modal.find(".anpopup_close");

				// пользовательская идентификация для модального окна
				if (options.id) {
					$modal.data("popup-id", options.id);
				} else {
					$modal.data("popup-id", "");
				}

				$.popup_display_modal_release(false, true, true);
				$modal.find(".anpopup_user_content").html(html);


				if (options.popup.block_window) {
					// если окно заблокировано, то кнопку закрытия скрываем, чтобы не вводила в заблуждение
					$close.hide();
				} else {
					$close.show();
				}

                $.popup_display_modal($modal, $.extend({}, options.popup, {
					init_pos:[$(window).width()/2, $(window).height()/2, false, 'center'],
					keep_on_close:true,
					on_hide: function() {
						$modal
							.data("popup-id","")
							.find('.anpopup_user_content').html('');

						if (options.popup.on_hide) {
							options.popup.on_hide();
						}
					}
				}));

                if (callback) {
                    callback($modal);
                }
            };

            if (json) {
                $.ajGetJSON(url, data, function(resp){
                    onLoadHtml(resp.html);
                }, false);
            } else {
                $.ajGet(url, data, function(resp){
                    onLoadHtml(resp);
                }, false);
            }
        };

        if ($(modalWindowSelector).size()==0) {
            $.ajGet(
                urlT('get_modal_container', 'menu'),
                {},
                function(resp){
					if ($(modalWindowSelector).size()==0){
						$('body').append($(resp));
					}
                    loadData();
                },
                false
            );
        } else {
            loadData();
        }
    },

	/**
	 * Проверяет активно или нет окно с заданным пользовательским идентификатором
	 *
	 * @param popupId
	 * @returns {boolean}
     */
	isModalOpen: function(popupId) {
		var modalWindowSelector = "[rel='modal_window']",
			$modal = $(modalWindowSelector + ":visible");

		if ($modal.length) {
			return $modal.data("popup-id") == popupId;
		} else {
			return false;
		}
	},

    closeAjModal    : function(without_animation){
        window['mdvKeep'] = 0;
        if (without_animation){
            $.popup_display_modal_release(false, false, true);
        }else{
            $.popup_display_modal_release();
        }
    },

    showImgGallery: function($control, callback){
        var options = {};
        if ($control.data('gallery_name')){
            options['is_gallery'] = true;
            options['gallery_name'] = $control.data('gallery_name');
        }
		var imgUrl = $control.data('img_url') ? $control.data('img_url') : $control.attr('src');
        if (!imgUrl && $control.attr('href')){
        	imgUrl = $control.attr('href');
		}
		this.showFullImage(imgUrl, callback, options);
    },

    showFullImage : function(img_url, callback, _options){
		var options = $.extend({}, {
			is_gallery: false,
			close_control: true
		}, _options);

		var items = [{
			src: img_url
		}];


		if (options['is_gallery']){
			items = [];

			var start_index = 0;

			var $gallery_items = $('[data-gallery_name="'+options['gallery_name']+'"]');
			var prev_flag = true;
			$gallery_items.each(function(i){
				var $control = $(this);
				var src_url = $control.data('img_url') ? $control.data('img_url') : $control.attr('src');
				if (!src_url && $control.attr('href')){
					src_url = $control.attr('href');
				}
				items.push({src: src_url});
				if (src_url==img_url){
					start_index = i;
				}
			});

		}

		$.magnificPopup.open({
			items: items,
			type: 'image',
			tLoading: 'Загрузка изображения...',
			mainClass: 'mfp-img-mobile mfp-fade',
			showCloseBtn: options.close_control,
			gallery: {
				enabled: true,
				preload: [0,1],
				navigateByImgClick: true,
				tPrev: 'Предыдущее изображение (клавиша влево)', // title for left button
				tNext: 'Следующее изображение (клавиша вправо)', // title for right button
				tCounter: '<span class="mfp-counter">%curr% из %total%</span>' // markup of counter
			},
			image: {
				tError: 'Ошибка загрузки изображения',
				titleSrc: 'title'
			},
			callbacks: {
				beforeOpen: function(){
					$('.general_header.float').css({
						'z-index': 1000
					});

					$('iframe').each(function(){
						if ($(this).css('position')=='fixed'){
							$(this).data('inited_z_index', $(this).css('z-index'));
							$(this).addClass('popup_mode_iframe_hided').css('z-index', 1);
						}
					});

					$('body').data('scroll_top', $(window).scrollTop());
					$('body').addClass('mfp-active');
				},
				open: function(){
					if (app.responsive_mode){
						var targetElement = this.wrap.get(0);
						bodyScrollLock.disableBodyScroll(targetElement);
					}

					if (app.responsive_mode){
						$('.mfp-content .mfp-figure').swipe(
							{
								swipe:function(event, direction, distance, duration, fingerCount, fingerData) {
									if (direction=='left'){
										$.magnificPopup.instance.next();
									}else if (direction=='right'){
										$.magnificPopup.instance.prev();
									}
								},
								allowPageScroll: 'vertical'
							}
						);
					}
					if (callback){
						window.setTimeout(function(){
							callback();
						}, 100);
					}

					$.magnificPopup.instance.next = function() {
						if (items.length>1){
							var self = this;
							self.wrap.removeClass('mfp-image-loaded');
						}
						setTimeout(function() { $.magnificPopup.proto.next.call(self); }, 120);
					}
					$.magnificPopup.instance.prev = function() {
						if (items.length>1){
							var self = this;
							self.wrap.removeClass('mfp-image-loaded');
						}
						setTimeout(function() { $.magnificPopup.proto.prev.call(self); }, 120);
					}
				},
				beforeClose: function(){
					if (app.responsive_mode) {
						bodyScrollLock.clearAllBodyScrollLocks();
						$('body').removeClass('mfp-active');
						$(window).scrollTop($('body').data('scroll_top'));
					}
				},
				afterClose: function(){
					$('iframe.popup_mode_iframe_hided').each(function(){
						$(this).removeClass('popup_mode_iframe_hided').css('z-index', $(this).data('inited_z_index'));
					});
				},
				imageLoadComplete: function() {

					var self = this;
					setTimeout(function() { self.wrap.addClass('mfp-image-loaded'); }, 16);

				}
			}
		}, start_index);

		return false;
    },

	shomPopupWindowPage: function(src, options){
		var plugin_options = {
			items: {
				src: src
			},
			type: options['data_type'] ? options['data_type'] : 'ajax',
			ajax: {
				settings: {
					data: {
						ajax: 1,
						popup: 1
					}
				},
				tError: '<a href="%url%">Страница</a> не загрузилась.'
			},
			mainClass: 'mfp-fade'+(options.extra_class ? ' '+options.extra_class : ''),
            removalDelay: options && options.removalDelay ? options.removalDelay : 300,
			alignTop: options && options.align && options.align=='top',
			closeOnBgClick: !options || !options.bgclick_close_off,
			enableEscapeKey: !options || !options.esc_key_close_off,
			tLoading: 'Загрузка данных...',
            callbacks: {
				beforeOpen: function(){
					$('.tooltipster-base').remove();
					$('.general_header.float').css({
						'z-index': 1000
					});

					$('iframe').each(function(){
						if ($(this).css('position')=='fixed'){
							$(this).data('inited_z_index', $(this).css('z-index'));
							$(this).addClass('popup_mode_iframe_hided').css('z-index', 1);
						}
					});

					$('body').data('scroll_top', $(window).scrollTop());
					$('body').addClass('mfp-active');
				},
				open: function(){
					if (app.responsive_mode){
						var targetElement = this.wrap.get(0);
						bodyScrollLock.disableBodyScroll(targetElement);
					}

					if (options && options.callbacks && options.callbacks.after_open){
						options.callbacks.after_open($(this.content));
					}
				},
				beforeClose: function(){
					if (app.responsive_mode) {
						bodyScrollLock.clearAllBodyScrollLocks();
						$('body').removeClass('mfp-active');
						$(window).scrollTop($('body').data('scroll_top'));
					}

					if (options && options.callbacks && options.callbacks.before_close){
						options.callbacks.before_close($(this.content));
					}

					if (app.responsive_mode){
						$('.mfp-content .mfp-close').remove();
					}
				},
				afterClose: function(){
					$('iframe.popup_mode_iframe_hided').each(function(){
						$(this).removeClass('popup_mode_iframe_hided').css('z-index', $(this).data('inited_z_index'));
					});

					if (options && options.callbacks && options.callbacks.close){
						options.callbacks.close();
					}
				},
                ajaxContentAdded: function () {
                    $(this.content).find('input[type="text"]:first').focus();
					commonOperations.maskFieldsMng.initFields();
					commonOperations.bindSmartPlaceholders();

					var scrollFloatObj = new commonOperations.scrollFloatPanelMngClass({
						$container : $('.mfp-wrap')
					});
					scrollFloatObj.init();

					if (options && options.callbacks && options.callbacks.ready){
						options.callbacks.ready($(this.content));
					}
                },parseAjax: function(mfpResponse) {
					if (mfpResponse.data && mfpResponse.data.success && mfpResponse.data.html){
						mfpResponse.data = mfpResponse.data.html;
					}
				}
            }
        };

		if (options && options.post_params){
			plugin_options.ajax.settings.type = 'POST';
			plugin_options.ajax.settings.data = options.post_params+'&ajax=1&popup=1';
		}

		if (options && options.modal){
			plugin_options['modal'] = true;
		}

		if ($.magnificPopup.instance.isOpen && !options.simple_close){
			$.magnificPopup.instance.st.removalDelay = 0;
			this.closePopupWindowPage();
			window.setTimeout(function(){
				return $.magnificPopup.open(plugin_options);
			}, 0);
		}else{
			return $.magnificPopup.open(plugin_options);
		}
	},

	closePopupWindowPage: function(){
		if ($.magnificPopup && $.magnificPopup.instance){
			$.magnificPopup.close();
		}
	},

	ifPopupWindowOpen : function(){
		if ($.magnificPopup.instance){
			return $.magnificPopup.instance.isOpen && ($('.mfp-container').size() > 0);
		}

		return false;
	},

	showImageOldModal : function(img_url, callback, _options){
		var options = $.extend({}, {
			is_gallery: false,
			stop_outer_close: false
		}, _options);

		var loadData = function(){
			var gallery_opened = $('[rel="modal_window"]').find('.anpopup_wrapper').hasClass('img');
			$('[rel="modal_window"]').find('.anpopup_wrapper').addClass('img');
			var img=new Image();
			$(img).load(function(){
				$('[rel="modal_window"]').find('.anpopup_user_content').removeClass('idle_indicator');
				if (gallery_opened){
					window['popups_stack']=[];
					$('[rel="modal_window"]').find('.anpopup_user_content').html('');
				}
				var $img = $(this);
				$img.css({maxHeight: $(window).height()*0.9, maxWidth: $(window).width()*0.9}).appendTo($('[rel="modal_window"]').find('.anpopup_user_content'));
				var params = {
					init_pos: [$(window).width() / 2, $(window).height() / 2, false, 'center'],
					keep_on_close: false,
					on_hide: function () {
						$('[rel="modal_window"]').find('.anpopup_wrapper').removeClass('img');
						$('[rel="modal_window"]').find('.anpopup_user_content').html('');
					},
					stop_outer_close: options.stop_outer_close
				};
				if (gallery_opened){
					params['effect_speed']=0;
				}

				$.popup_display_modal( $('[rel="modal_window"]'), params);

				if (options['is_gallery']){
					$('[rel="modal_window"]').find('.anpopup_user_content').find('.gallery_control').remove();
					var $gallery_items = $('[data-gallery_name="'+options['gallery_name']+'"]');
					var $prev=null;
					var $next=null;
					$gallery_items.each(function(i){
						if ($(this).is(options['gallery_active'])){
							if (i>0){
								$prev = $gallery_items[i-1];
							}
							if (i!=($gallery_items.length-1)){
								$next = $gallery_items[i+1];
							}
						}
					});
					if ($next!=null){
						var $next_control = $('<div></div>').addClass('gallery_control gallery_control_next');
						$('[rel="modal_window"]').find('.anpopup_user_content').append($next_control);
						$next_control.on('click', function(){
							$('[rel="modal_window"]').find('.anpopup_user_content').addClass('idle_indicato');
							commonOperations.showImgGallery($($next));
						});
						$img.on('click', function(){
							$next_control.trigger('click');
						});
					}
					if ($prev!=null){
						var $prev_control = $('<div></div>').addClass('gallery_control gallery_control_prev');
						$('[rel="modal_window"]').find('.anpopup_user_content').append($prev_control);
						$prev_control.on('click', function(){
							$('[rel="modal_window"]').find('.anpopup_user_content').addClass('idle_indicator');
							commonOperations.showImgGallery($($prev));
						})
					}
				}

				if (callback){
					callback();
				}
			});

			img.src=img_url;

		}

		if ($('[rel="modal_window"]').size()==0){
			$.ajGet(
				urlT('get_modal_container', 'menu'),
				{},
				function(resp){
					var $div = $('<div>').html(resp);
					$('body').append($div.find('div:first'));
					loadData();
				},
				false
			);
		}else{
			loadData();
		}
	},

    operationInfoBar: {
        show: function(options){
            $('.operation_info_bar').remove();
            var $bar = $('<div></div>').addClass('operation_info_bar').html(options.html).hide();
            $('body').append($bar);
            var position = options.getPositionFnc($bar);
            $bar.css({left: position.x, top: position.y}).fadeIn();
            if (options.onShowCallback){
				options.onShowCallback($bar);
			}

            var setTimeoutHideFnc = function(interval){
                return window.setInterval(function(){
                    if ($bar.size()>0 && !$bar.hasClass('hovered')){
                        $bar.fadeOut(function(){$(this).remove();});
                        window.clearInterval($bar.data('timeout'));
                    }
                }, interval)
            }

            $bar.data('timeout', setTimeoutHideFnc(2000));
            $bar.on('mouseenter', function(){
                $bar.addClass('hovered');
            });
            $bar.on('mouseleave', function(){
                $bar.removeClass('hovered');
                $bar.data('timeout', setTimeoutHideFnc(300));
            });
        }
    },

	reloadEditorInlineElements: function($container){
		$container.find('.video_inline').each(function(){
			$(this).next('.video_in_text').remove();
			$(this).removeClass('loaded').removeClass('idle').show();
		});

		this.loadEditorInlineElements($container);
	},

    loadEditorInlineElements: function($container){
		var updateFromPreview = function($preview, indicator){
			if ($preview.hasClass('idle')){
				return;
			}
			var $video_in_text = $preview.closest('.video_in_text');
			$preview.addClass('idle');
			if (indicator){
				$preview.addClass('idle_indicator');
			}

			$.ajPost(urlA('get_video_embbed', 'post'), {url: decodeURIComponent($video_in_text.data('url'))+'?autoplay='+($preview.hasClass('autoplay') ? 1 : 0), w:$video_in_text.width(), h:$video_in_text.height()}, function(resp){
				var $temp = $('<div>').html(resp).hide();
				$video_in_text.append($temp);
				window.setTimeout(function(){
					$preview.remove();
					$temp.show();
				}, indicator ? 500 : 1000);
			}, false);
		}

		$container.on('click', '.user_video_preview', function(){
			$(this).addClass('autoplay');
			updateFromPreview($(this), true);
		});

		window.setTimeout(function(){
			var checkerFnc = function(){
				var $node = $container.find('.video_inline:not(.idle):not(.loaded)').first();
				if ($node.size()==0){
					var UA = navigator.userAgent;
					if (/Android/.test(UA) && !/Firefox/.test(UA) || /iP(hone|od)/i.test(UA)){
						$container.find('.user_video_preview').each(function(){
							updateFromPreview($(this), false);
						});
					}
					return;
				}
				$node.addClass('idle');

				var url = decodeURIComponent($node.data('url'));
				var vw = $node.width();
				var vh=Math.ceil(vw*(9/16));

				if ($node.data('reversed_ratio')){
					vh=Math.ceil(vw*(16/9));
				}

				$.ajPost(urlA('get_video_embbed_preview', 'post'), {url:url, w:vw, h:vh}, function(resp){
					if (resp.meta && resp.meta.aspect_ratio && resp.meta.aspect_ratio>0 && url!='https://vimeo.com/748714554'){
						vh=Math.ceil(vw/resp.meta.aspect_ratio);
					}
					if(resp.html!=''){
						var $video_in_text = $('<span class="video_in_text" data-width="' + vw + '" data-height="' + vh + '" data-url="' + $node.data('url') + '" style="min-width:' + vw + 'px;min-height:' + vh + 'px;"></span>').html(resp.html);
                        $node.after($video_in_text);
						$video_in_text.height($video_in_text.height());

						if (url.indexOf("/video/")>-1){
							window.setTimeout(function(){
								if ($video_in_text.is(':visible')){
									commonOperations.logPlayerEvent('preview', {
										par1: $node.data('url'),
										par2: location.href
									});
								}
							}, 1000);
						}
					}

					$node.addClass('loaded').hide();
					window.setTimeout(function(){
						checkerFnc();
					}, 0)
				}, false, 'json');
			}

			checkerFnc();

			$container.find('img').parent('a:not(.post_img_inline_link)').each(function(){
				if ($(this).closest('.user_info').size()==0 && $(this).closest('.as_author_icons').size()==0){
					$(this).addClass('post_img_inline_link');
				}
			});

			commonOperations.bindIRVote($container);

			$container.find('.new_redactor').find('a[href^="http"]').each(function(){
				if ($(this).find('.a_tail').size()>0){
					return true;
				}
				if ($(this).children().size()>0){
					return true;
				}
				var parts = $(this).html().split(' ');
				if (parts.length>1){
					$(this).html(parts.slice(0, -2).join(' ')+' <span class="a_tail">'+parts.slice(-2).join(' ')+'</span>');
				}
			});

			$container.find('a[href*="youtube.com"], a[href*="youtu.be"], a[href*="vimeo.com"], a[href*="'+app.host+'/video/"], a[href*="'+app.host+'/media/video/"]').each(function(){
				if ($(this).closest('.user_info').size()==0 && $(this).closest('.as_author_icons').size()==0){
					$(this).addClass('popup_embed_video');
				}
			})

		}, 100);
    },

	bindIRVote: function($container){
		$container.find('.ir_vote_code').each(function(){
			var $vote_field = $(this);
            if ($vote_field.hasClass('processed')){
				return false;
			}

			var voteKey = $vote_field.data('hash');
			var item_type = 'none';
			var item_id = 0;

			var $item = $vote_field.closest('.item');
			if ($item.size()>0){
				if ($item.data('item_type')){
					item_type = $item.data('item_type');
					item_id = $item.data('item_id');
				}
			}


			$.ajGetJSON(urlT('ir_vote_code_visible_status', '')+'/'+voteKey, {
				item_type: item_type,
				item_id: item_id
			}, function(resp){
				if (resp.status==0){
					$vote_field.remove();
				}else{
					$vote_field.find('.ir_vote_answer').each(function(){
						var parts = $(this).text().split('|DELIMITER|');
						var text = parts[0];
						var operations = parts[1];
						var $answer = $(this);
						$answer.text(text);
						$answer.data('operations', operations);
					});
					$vote_field.on('click', '.ir_vote_answer', function(){
						var $answer = $(this);
						$.ajPost(
							urlA('ir_vote_code_action', 'user'),
							{
								operations: $answer.data('operations'),
								vote_key: voteKey,
								location: $item.find('a.anchor').size()>0 ? $item.find('a.anchor').attr('href') : location.href,
								referer: document.referrer
							},
							function(resp){

							},
							false
						);
						$vote_field.html('Спасибо за Вашу активность!').addClass('finished');
					});
					$vote_field.addClass('processed');
					$vote_field.show();
				}
			}, false);
		});
	},

	phoneNumberMng: {
		getInfo: function(phonenumber){
			var result = {
				is_empty: false,
				is_valid: false,
				is_possible: false,
				value: '',
				country: '',
				country_code: '',
				international: '',
				national: '',
				formatted: '',
				template: '',
				type: ''
			}
			if (phonenumber==''){
				result.is_empty = true;

				return result;
			}

			if (phonenumber[0]!='+'){
				phonenumber = '+'+phonenumber
			}

			result.formatted = new libphonenumber.AsYouType().input(phonenumber);
			result.template = result.formatted.replaceAll(/[^\s]{1}/, "#");

			try{
				var length_corrected = false;
				var original_length = phonenumber.length;
				if (original_length<=3){
					phonenumber += '000';
					length_corrected = true;
				}

				var libphone = new libphonenumber.parsePhoneNumber(phonenumber);

				result.is_valid = libphone.isValid();
				result.is_possible = libphone.isPossible();
				result.country = libphone.country;
				result.country_code = libphone.countryCallingCode;
				if (!length_corrected){
					result.value = libphone.number;
					result.international = libphone.formatInternational();
					result.national = libphone.formatNational();
					result.type = libphone.getType();
				}
			}catch (e) {

			}

			return result;
		},

		prepareField: function($field){
			if (!$field.data('start_empty') && $field.val()==''){
				$field.val('+7');
			}

			var _this = this;
			$field.bind("click change keyup paste cut", function(){
				var $this = $(this);
				var timeout_ms = 50;

				var new_value = $this.val();
				var prev_value = '';

				if ($this.data('value')){
					prev_value = $this.data('value');
				}

				if(prev_value!=new_value){
					prev_value = new_value;
					$this.data('value', prev_value);


					if($this.data('tm')>0) clearTimeout($this.data('tm'));


					$this.data('tm', setTimeout(function(){
						_this.onFieldValueChange($this, $this.val());
					}, timeout_ms));
				}
			});

			$field.trigger('change');
		},

		onFieldValueChange: function($field, value){
			var phone_info = commonOperations.phoneNumberMng.getInfo(value);
			if (value != phone_info.formatted && phone_info.formatted!=''){
				$field.val(phone_info.formatted);
			}

			var is_valid = $field.hasClass('valid');
			if (phone_info.is_valid){
				$field.addClass('valid');
				if (!is_valid){
					$field.trigger('valid_state');
				}
			}else{
				$field.removeClass('valid');
				if (is_valid){
					$field.trigger('valid_state');
				}
			}
		}
	},

    scrollFloatPanelMngClass: function(options){
        var default_options = {
			$container: $(window),
			position: 'top',
            intervals:{
                top: 10,
                bottom: 100,
				helper_bottom_correct: 0
            },
            clone_helper:false,
            selector: '.scroll_float_panel',
            callbacks: {
                onFloat: false,
				onCloneHelperCreate: false,
				beforeCreateCloneHelper: false,
				onCloneHelperRemove: false
            }
        }

        var _objMng = function(options){
            this.options = $.extend(true, {}, default_options, options);
        }

        _objMng.prototype = {
            init: function(){

                var _this = this;
                this.options.$container.on('scroll.float_panel', function(){
					var callback = function(){
						var $objects = $(_this.options.selector+':not(.float_helper):visible');
						$objects.each(function(){
							var $item = $(this);
							var $container = $item.closest($item.data('container'));
							var offset_top = $container.offset().top;
							var scrollTop = $(window).scrollTop();

							if (!$item.hasClass('not_float') && offset_top < (scrollTop+_this.options.intervals.top) &&
								(($container.height()+offset_top) > (scrollTop+_this.options.intervals.bottom+_this.options.intervals.top)) &&
								(
									($item.offset().top <= (scrollTop+_this.options.intervals.top))
									||
									(_this.options.position=='bottom' && $item.hasClass('float_mode_on'))
								) &&
								(($item.hasClass('float_mode_on') && (scrollTop+_this.options.intervals.top)>$item.data('offset')) || !$item.hasClass('float_mode_on'))
							){
								if (!$item.hasClass('float_mode_on')){
									var diff =$item.offset().left - $container.offset().left;

									if (_this.options.clone_helper){
										if (_this.options.callbacks.beforeCreateCloneHelper){
											_this.options.callbacks.beforeCreateCloneHelper($item);
										}
										var $item_clone = $item.clone(true).addClass('not_float clone').addClass('float_helper').width($item.outerWidth()).height($item.outerHeight(true)).css({zIndex:19900});
										$item.after($item_clone);
										if (_this.options.callbacks.onCloneHelperCreate){
											_this.options.callbacks.onCloneHelperCreate($item, $item_clone);
										}
									}else{
										var $float_helper = $('<div></div>').addClass('float_helper');
										if ($item.css('position')!='absolute'){
											$item.after($float_helper.width($item.outerWidth(true)).height($item.outerHeight(true)));
										}else{
											$item.after($float_helper.width(0).height(0));
										}
										$float_helper.css('max-width', '100%');
									}

									var margin_correct = ($item.outerWidth(true)-$item.outerWidth())/2+parseInt($item.css('border-left-width'));

									var offset = $item.offset();
									$item.data('offset', $item.offset().top+parseInt($item.css('marginTop')));
									$item.data('init_width', $item.width());

									$item.addClass('float_mode_on');
									$item.data('instant_css', {
										position: $item.css('position'),
										top: $item.css('top'),
										left: $item.css('left')
									});

									if ($item.data('fix_width')){
										$item.css('width', $item.width());
									}
									$item.hide();
									$item.css({
										position: 'fixed',
										left: offset.left-margin_correct,
										zIndex: 5000
									});

									if (_this.options.position=='top'){
										$item.css({
											top: _this.options.intervals.top
										});
									}else if(_this.options.position=='bottom'){
										$item.css({
											bottom: _this.options.intervals.bottom
										});
									}

									$item.fadeIn();

									if (_this.options.callbacks.onFloat){
										_this.options.callbacks.onFloat($item);
									}
								}else{

									if (($item.siblings('.float_helper').position().top+$item.siblings('.float_helper').outerHeight()+_this.options.intervals['helper_bottom_correct']) < (_this.options.$container.scrollTop()+$item.outerHeight())){
										$item.addClass('helper_hidden');
									}else{
										$item.removeClass('helper_hidden');
									}
								}
								_this.options.$container.on('resize', function(){
									if (_this.options.callbacks.onResize){
										_this.options.callbacks.onResize($item);
									}

									if ($item.is('.float_mode_on:visible')){
										$item.css({
											left: $container.offset().left+diff
										});
									}
								});
							}else{
								if ($item.hasClass('float_mode_on')){
									$item.removeClass('float_mode_on');
									$item.removeClass('helper_hidden');
									$item.fadeOut(100, function(){
										$(this).siblings('.float_helper').remove();
										var instant_css = $item.data('instant_css');
										$item.show().css({
											position: instant_css['position'],
											top: instant_css['top'],
											left: instant_css['left']
										});

										if (_this.options.callbacks.onCloneHelperRemove){
											_this.options.callbacks.onCloneHelperRemove($item);
										}
									});
								}
							}
						});
					}

					if (_this.scrollTimeout) {
						clearTimeout(_this.scrollTimeout);
					}
					_this.scrollTimeout =  setTimeout(function(){
						callback();
					},50);
                });
            }
        }

        var objMng = new _objMng(options);
        return objMng;
    },

    bindBlockStateIcon: function(options){
        var default_options = {
            container: 'body'
        }
        options = $.extend(true, {}, default_options, options);

        $(options.container).on('click', '.title', function(e){
            if ($(e.target).closest('.title_control_block ').size()>0){
                return;
            }
            var $state_icon = $(this).find('.state_icon');
            var name = $state_icon.data('name');
            var state_icon_exist = $state_icon.size();
            if (!state_icon_exist){
                return;
            }
            var $container = $state_icon.closest(options.container);
            var $relations = $container.find($state_icon.data('relations'));
            if ($container.hasClass('active')){
                $relations.slideUp('fast', function(){
					$container.removeClass('active');
				});
                setCookie('bstate|'+name, 0, 365);
            }else{
                $relations.slideDown();
				$container.addClass('active');
                setCookie('bstate|'+name, 1, 365);
            }
        });
    },

	loadLangs: function(langs_keys, callback){
		var response = {};
		$.ajPost(app.host + '/menu/get_langs', {keys: langs_keys}, function(resp){
			for (var i in resp){
				response[i] = resp[i];
			}
			if (callback){
				callback(response);
			}
		}, false, 'json');
	},

	maskFieldsMng: {
		initFields: function(){
			var self = this;
			$('body input.masked').each(function(){
				self.initMask($(this));
			});

			$('body').on('focus', 'input.masked', function(){
				self.initMask($(this));
			});
		},

		initMask : function($field){
			if ($field.hasClass('mask_inited')){
				return;
			}
			var mask_type = $field.data('mask_type');
			var mask  = $field.data('mask_value');

			if (mask_type=='price'){
				$field.unmask().mask("# ###", {reverse: true});
			}else if (mask_type=='percent'){
				$field.unmask().mask("900");
			}else if (mask_type=='verify_code'){
				$field.unmask().mask("9000");
			}else if (mask_type=='time'){
				$field.unmask().mask("00:00", {placeholder: "  :  "});
			}else if (mask_type=='time_full'){
				$field.unmask().mask("00:00:00", {placeholder: "  :  :  "});
			}else if (mask_type=='date'){
				$field.unmask().mask("00.00.0000", {placeholder: "  .  .    "});
			}else if(mask){
				$field.unmask().mask(mask);
			}

			$field.addClass('mask_inited')
		},

		getValue : function($field){
			return $field.cleanVal();
		},

		setValue : function($field, value){
			return $field.val($field.masked(value));
		}
	},

	initDatepickers: function(){
		$('body').on('mouseenter', '.datepicker_v2', function(e){
			if (!$(this).hasClass('datepicker_inited')){
				var $picker = $(this);
				var options = {
					format	: 'd.m.Y',
					hide_on_select: true,
					locale: 'ru',
					date: $(this).prev('.date_field').val(),
					calendars: $(this).data('calendars') ? $(this).data('calendars') : 2,
				};

				if ($(this).data('max')){
					options.max = $(this).data('max');
				}
				if ($(this).data('min')){
					options.min = $(this).data('min');
				}

				pickmeup(this, options);

				this.addEventListener('pickmeup-change', function (e) {
					$picker.prev('.date_field').val(e.detail.formatted_date).trigger('change');
				});

				this.addEventListener('pickmeup-show', function (e) {
					pickmeup(this).set_date($picker.prev('.date_field').val());
				});

				$(this).addClass('datepicker_inited');
			}
		});

	},

	initClipboardCopy: function(){
		$('body').on('mouseenter', '.common_clipboard_copy', function(e){
			if (!$(this).hasClass('clipboard_inited')){
				if (!$(this).data('clipboard-text')){
					if ($(this).attr('href')){
						$(this).attr('data-clipboard-text', $(this).attr('href'));
					}else{
						$(this).attr('data-clipboard-text', $(this).text());
					}
				}
				var clipboards = new ClipboardJS($(this).get(0));
				clipboards.on('success', function(e) {
					var $node = $(e.trigger);
					if ($node.hasClass('tooltipstered')){
						$node.tooltipster('destroy');
					}
					$node.tooltipster({
						animation: 'fade',
						side: 'top',
						theme: 'tooltipster-light',
						arrow: true,
						contentAsHTML: false,
						debug: false,
						updateAnimation: 'none',
						content: "Скопировано в буфер",
						functionAfter: function(){
							$node.tooltipster('destroy');
						}
					}).tooltipster('open');
				});

				$(this).addClass('clipboard_inited');
			}

			e.preventDefault();
		});

		$('body').on('click', '.common_clipboard_copy', function(e){
			e.preventDefault();
			e.stopPropagation();
			return false;
		});
	},

	bindSmartPlaceholders: function($block){
		if (!$block){
			$block = $('body');
		}

		$block.find('.smart_placeholder').each(function(){
			if ($(this).hasClass('sp_inited')){
				return true;
			}

			$(this).addClass('sp_inited')

			var $field = $(this);
			if ($field.is(':visible')){
				$field.height($field.outerHeight());
			}
			var $wrapper = $field.closest('div');
			var $help_block = $wrapper.find('.smart_placeholder_block');
			if ($help_block.size()==0){
				$help_block = $('<div class="smart_placeholder_block"></div>');
				$help_block.text($field.attr('placeholder'));
				$wrapper.append($help_block);
			}
			if ($field.val()==''){
				$wrapper.removeClass('smart_placeholder_inited');
			}else{
				$wrapper.addClass('smart_placeholder_inited');
			}
		});
	},

	initSmartPlaceholders: function(){
		$('body').on('click change cut paste keyup', '.smart_placeholder.sp_inited', function(e){
			var $field = $(this);
			var $wrapper = $field.closest('div');
			if ($field.val()==''){
				$wrapper.removeClass('smart_placeholder_inited');
			}else {
				$wrapper.addClass('smart_placeholder_inited');
			}
		});
	},

	initParentRelationActions: function(){
		$('body').on('change', ':input[data-relation_parent="1"], [data-relation_parent="1"] :input', function(){
			var $field = $(this);
			var name = $field.data('child_relation_name');
			if (!name){
				name = $field.attr('name');
			}
			var value;
			if ($field.attr('type')=='checkbox'){
				value = $field.prop('checked') ? 1 : 0;
			}else if ($field.attr('type')=='radio'){
				value = $('[type="radio"][name="'+name+'"]:checked').val();
			}else{
				value = $field.val()
			}


			var $visibility_relation_lines = $('.common_block_relation[data-relation_name="'+name+'"]');

			$visibility_relation_lines.addClass('hidden');
			$visibility_relation_lines.each(function(){
				var $item = $(this);
				var match_values = $(this).data('relation_values');

				var is_visible = false;

				for (var mi in match_values){
					var match_value = match_values[mi];
					if (value==match_value){
						is_visible = true;
						break;
					}
				}

				if (is_visible){
					$item.removeClass('hidden');
					$item.find('input[type="text"]').first().focus();
				}
			});
		});
	},

	_log_xhr : null,
	logPlayerEvent: function(event, params, counter){
		var _this = this;
		if (!counter){
			counter = 0;
		}

		if (counter>=15){
			return;
		}

		params['event'] = event;
		if (this._log_xhr){
			window.setTimeout(function(){
				_this.logPlayerEvent(event, params, counter+1);
			}, 1000);

			return;
		}
		this._log_xhr = $.ajax({
			type:'POST',
			url:app.host+'/videoplayer_log',
			data:params,
			complete: function(){
				_this._log_xhr = false
			}
		});
	},

	valueLabelMngClass: function(options){
		var default_options = {
			$block: $(window),
			getAutocompleteUrlFnc: function ($field) {
				return $field.data('autocomplete_url');
			},
			onSelectCallback: false,
			onLabelRemoveCallback: false,
		}

		var _objMng = function(options){
			this.options = $.extend(true, {}, default_options, options);
		}

		_objMng.prototype = {
			init: function(){
				var _this = this;

				_this.initAutocomplete();
				_this.initLabelsActions();
			},

			initLabelsActions: function(){
				var _this = this;
				this.options.$block.on('click', '.value_label .remove_link', function(){
					var $value_label = $(this).closest('.value_label');
					var $field = $value_label.siblings('.autocomplete');
					if ($field.size()==0){
						$field = $value_label.closest('.param_values').find('.autocomplete');
					}
					$value_label.remove();
					$field.next('.acm_area').css({
						left: 0
					});
					if ($field.data('single_mode')){
						$field.show().trigger('keyup').trigger('click').focus();
					}

					if (_this.options.onLabelRemoveCallback){
						_this.options.onLabelRemoveCallback();
					}
				});
			},

			initAutocomplete: function(){
				var _this = this;
				this.options.$block.find("input.autocomplete").each(function () {
					var $field = $(this);
					$field.autocomplete({
						url: _this.options.getAutocompleteUrlFnc($field),
						allow_empty: true,
						limit_count: 5,
						timeout_ms: 100,
						modifyPost: function (request_data) {
							var $param_values = $(this).closest('.param_values');
							var exclude = {};
							var i = 0;
							$param_values.find('.value_label').each(function () {
								exclude[i] = $(this).data('value');
								i++;
							});
							request_data['exclude'] = exclude;
							if ($field.data('post_params')){
								for (var _name in $field.data('post_params')){
									request_data[_name] = $field.data('post_params')[_name];
								}
							}
							return request_data;
						},

						onSelect: function ($input_field, $item, uid) {
							if ($item.hasClass('group_items')){
								var items = $item.data('group_items');
								for (var i in items){
									var _item = items[i];

									_this.addValueLabel($field, _item['id'], _item['label'], _item['title'], _item['link']);
								}
							}else{
								var id = uid;
								var label = $item.find('.acm_item_value').data('label');
								var link = $item.find('.acm_item_value').data('link') ? decodeURIComponent($item.find('.acm_item_value').data('link')) : '';
								var title = $item.find('.acm_item_value').text();
								var extra_data = $item.find('.acm_item_value').data('extra_data') ? $item.find('.acm_item_value').data('extra_data') : '';

								var $label = _this.addValueLabel($field, id, label, title, link);
							}

							$field.val($input_field.val());
							if ($field.data('single_mode')){
								$field.hide();
							}

							window.setTimeout(function () {
								$field.removeClass('choosen');
								if (!$field.data('single_mode')){
									$field.trigger('keyup').trigger('click').focus();
								}
							}, 100);

							if (_this.options.onSelectCallback){
								_this.options.onSelectCallback($field, $label, extra_data);
							}


							return false;
						}
					});
				});
			},

			addValueLabel: function($field, id, label, title, link){
				var value_line_id = generateRandomId();

				var $a_remove = $('<a class="remove_link a_icon a_icon_delete"></a>');
				var label_tpl = label;
				if (link!=''){
					label_tpl = '<a href="'+link+'" target="_blank">'+label+'</a>';
				}
				var $label = $("<div class='value_label' title='" + title + "' data-value='"+id+"'>" + label_tpl + "</div>")
					.append($('<input type="hidden" name="' + $field.data('hidden_name') + '['+value_line_id+'][id]" value="' + id + '">'))
					.append($('<input type="hidden" name="' + $field.data('hidden_name') + '['+value_line_id+'][label]" value="' + label + '">'))
					.append($('<input type="hidden" name="' + $field.data('hidden_name') + '['+value_line_id+'][title]" value="' + title + '">'))
					.append($a_remove);

				if (link!=''){
					$label.append($('<input type="hidden" name="' + $field.data('hidden_name') + '['+value_line_id+'][link]" value="' + link + '">'));
				}

				var $param_values = $field.closest('.param_values');
				if ($param_values.find('.value_label').size()>0){
					$param_values.find('.value_label').last().after($label);
				}else{
					$param_values.prepend($label);
				}

				if ($field.next('.acm_area').size()){

					$field.next('.acm_area').css({
						left: $field.position().left + 'px'
					});
				}

				return $label;
			}
		}

		var objMng = new _objMng(options);
		objMng.init();
		return objMng;
	},

	getBlockRequestParamsStr: function($block){
		var data = '';
		$block.find(':input').each(function(){
			if ($(this).attr('type')=='radio' || $(this).attr('type')=='checkbox'){
				if (!$(this).prop('checked')){
					return true;
				}
			}
			if (
				$(this).closest('div.field.hidden').size()==0
			){
				if ($(this).attr('name')){
					data += (data=='' ? '' : '&')+$(this).attr('name')+'='+encodeURIComponent($(this).val());
				}
			}
		});

		return data;
	},

	getHash: function(str){

		var hash = 0;
		for (var i = 0, len = str.length; i < len; i++) {
			var chr = str.charCodeAt(i);
			hash = (hash << 5) - hash + chr;
			hash |= 0; // Convert to 32bit integer
		}
		return hash;

	}
}

initSRadio=function($chk){
	if($chk.length==0 || $chk.data('initiated')) return false;

	var inpPrefix=$chk.attr('class').match(/srd_[^\s]+/).pop();
	$chk.click(function(e){
		if(e.target.type=='radio'){
			var input=$(this).find('input').get(0);
			var $node=$(this).find('.sradioi');
			$(input).closest('form').find('.'+inpPrefix+' .sradioi_check').removeClass('sradioi_check');			
			$node.addClass('sradioi_check');
		}
	});
	
	$chk.data('initiated', 1);
}

uiLivePayQuery=function(live_id, options){
	$.ajGetJSON(urlA('item_pay', 'live')+'/'+live_id, {}, function(resp){
		if(options.onQueryComplete) options.onQueryComplete(resp);

		if(resp['access_granted']){
			if(options.onItemAccess) options.onItemAccess([live_id]);
		} else if (resp.redirect_url){
			location.href = resp.redirect_url;
			return false;
		} else if(resp['bill']){
			app.redirect('pay/'+resp.bill.bl_id);
		}
		
		if(resp['popup'] && resp['inv_type']=='restrict' && !resp.html){
			//Show invoice in new window
			location.href = resp.inv_page_url;
		} else if(resp['popup']){
			//Show popup
			$('#ext_pop').html(resp.html);
			
			$.popup_display_modal($('#ext_pop .mpop'), {
				init_pos:[$(window).width()/2, $(window).height()/2, function(){
					invoiceMng.init({
						onItemAccess:options.onItemAccess
					});
				}, 'center']
			});
		} else if(resp['auth_req']){
			authReq({
				onAuth:function(user){
					$.ajGetJSON(urlA('item_pay_proceed', 'live')+'/subscribe', {live_id:live_id}, function(resp){
						location.href=resp.live_url;
					});
				}
			})
		}
	}, false, false);
}

uiBindGroupInvoicePayAction=function($obj, item_id, options){
    var MODES = {
        JOIN: 'join',
        EXTEND: 'extend',
        EXTEND_MENU: 'extend_menu'
    };
    var default_options = {
        onItemAccess: function(res_item_id){
            location.href = app.url+'/group/'+res_item_id;
        },
        onQueryComplete: false,
        onControlClick: false,
        mode: MODES.JOIN,
		confirm: 0
    }

    options = $.extend({}, default_options, options);

    if(options.onControlClick) options.onControlClick();

    $obj.on('click', function(e){
		if ($(e.target).is('.version_detail_link')){
			return true;
		}
        var $button = $(this);
        if ($button.hasClass('disabled') || $button.hasClass('idle')){
            return false;
        }

        if (item_id==null){
            item_id = $button.data('id');
        }

        if (!$button.data('noindicator')){
            if ($button.data('indicator_type')=='2'){
                $button.addClass('idle').addClass('idle_indicator');
            }else{
                var color = $button.closest('#member_menu').size()>0 ? '#000000' : ($button.closest('.head').size() == 0 ? undefined : '#FFFFFF');

                app.switchButtonIdle($button, true, color);
            }
        }else{
            $button.addClass('idle');
        }

		var version_id = $button.data('version_id');
		if (!version_id){
			version_id = options.version_id;
		}
		var params = {mode: options.mode, version_id: version_id, confirm: options.confirm};
		if ($button.data('sale_id')){
			params['sale_id'] = $button.data('sale_id');
		}

        $.ajGetJSON(urlA('item_pay', 'group')+'/'+item_id, params, function(resp){
            if(options.onQueryComplete) options.onQueryComplete(resp);

			if(resp['redirect_url']){
				location.href = resp['redirect_url'];
				return;
			}

            if(resp['access_granted']){
                return options.onItemAccess(item_id);
            } else if(resp['bill']){
                commonOperations.closeAjModal(true);
                commonOperations.closePopupWindowPage();
                return app.redirect('pay/'+resp.bill.bl_id);
            }

            if (!$button.data('noindicator')){
                window.setTimeout(function(){
                    if ($button.data('indicator_type')=='2'){
                        $button.removeClass('idle').removeClass('idle_indicator');
                    }else{
                        app.switchButtonIdle($button, false);
                    }
                }, 1000);
            }else{
                $button.removeClass('idle');
            }

            if(resp['popup']){

				commonOperations.shomPopupWindowPage(resp.html, {
					data_type: 'inline',
					bgclick_close_off: true,
					extra_class: app.responsive_mode ? '' : 'mfp-width-auto',
					callbacks: {
						after_open: function(){
							invoiceMng.init({
								onItemAccess:function(subscribed){
									$.each(subscribed, function(i, item_id){ options.onItemAccess(item_id); });
								}
							});
						}
					}
				});

                /*$('#ext_pop').html(resp.html);

                $.popup_display_modal($('#ext_pop .mpop'), {
                    init_pos:[$(window).width()/2, $(window).height()/2, function(){
                        invoiceMng.init({
                            onItemAccess:function(subscribed){
                                $.each(subscribed, function(i, item_id){ options.onItemAccess(item_id); });
                            }
                        });
                    }, 'center']
                });*/
            } else if(resp['auth_req']){

                authReq({
                    onAuth:function(user){
                            $.ajGetJSON(urlA('item_pay_proceed', 'group')+'/subscribe', {item_id:item_id, version_id: $button.data('version_id')}, function(resp){
							if (resp.redirect_url){
								location.href = resp.redirect_url;
								return false;
							}else if (typeof(resp.need_retry)!="undefined"){
								commonOperations.closeAjModal(true);
								commonOperations.closePopupWindowPage();
                                app.switchButtonIdle($button, false);
                                $obj.trigger('click');
                                return false;
                            }else{
								return options.onItemAccess(item_id);
							}
                        });
                    }
                });
            }
        }, false);

        return false;
    });
}

var pageViewMng = {
    inited : false,
    init: function(){
        this.inited = true;
    },
    getHits : function(){
        var cookie = getCookie('view_counter');
        return  cookie=="" ? 0 : parseInt(cookie);
    },
	recordHit : function(){
		if (this.inited){
			setCookie('view_counter', this.getHits()+1, null);
		}
	}
}

var highlightAreaMng = {
    options : {
        padding: 5,
        selector: '.highlight_area'
    },
    run: function(options){
        this.options = $.extend({}, this.options, options, true);
        this.highlight();
        $(window).on('resize.highlight', function(){
            highlightAreaMng.highlight();
        });

        $(window).on('click.highlight', function(){
            $('body').removeClass('highlight_blured');
            $('body').find('.highlight_clone').remove();
            $('body').find('.highlight_block_layer').remove();
            $(window).off('click.highlight');
        });

    },
    highlight: function(){

        $('body').find('.highlight_clone').remove();
        $('body').find('.highlight_block_layer').remove();
        var coordinates = this.getElementPosition();

        this.prepareBlockLayers(coordinates);
		
        var $clone_element = $(this.options.selector).filter(':visible').clone('true');
		if ($clone_element.size()==0){
			return;
		}
        $clone_element.addClass('highlight_clone').css({
            position: 'absolute',
            left: coordinates.leftTop.x,
            top: coordinates.leftTop.y
        }).appendTo($('body'));

        app.loadStatic(['user/js/ajax_tooltip.js'], true, function(){
            window.setTimeout(function(){
                $('body').addClass('highlight_blured');
            }, 300);
            ajTooltipMng.init({
                plugin_selector: '.highlight_clone',
                require_width: 300,
                position_mode: "horizontal",
                position_priority: "right",
                TIME_TO_SHOW_PROGRESS_MS: 200,
                TIME_TO_SHOW_MOUSEENTER_MS: 0,
                init_action: 'click',
                extraClass: 'highlight_clone_tooltip',
                html_content: true
            });
            $('.highlight_clone').trigger('click');
        });
    },
    getElementPosition: function(){
        var $element = $(this.options.selector);
        var position = $element.offset();
        var width = $element.outerWidth();
        var height = $element.height();

        return {leftTop:{x:position.left, y:position.top}, rightBottom:{x:position.left+width, y:position.top+height}}
    },
    prepareBlockLayers: function(coordinates){
        var window_size = {
            w: $(window).width(),
            h: $(document).height()
        }

        $('<div></div>').addClass('highlight_block_layer').addClass('hbl_all').css({
            left: 0,
            top: 0,
            width: window_size.w +'px',
            height: window_size.h+'px'
        }).appendTo($('body'));
    }
}

var swfuCancelUpload=function(uniqId){
	$.get(urlA('cancel_upload', 'user'), {uniqId:uniqId});
}

var swfuCreateUploadingProcessElements=function(uploader, file_id, uniq_id, $upload, options){
    var $item = $('<div></div>').attr({'class':'progressBlock', 'id':file_id});
	
    var $progressCancel = $('<div></div>').attr({'class': 'progressCancelBlock'});
    $progressCancel.html('<a>'+'Отменить загрузку'+'</a>');

    if(options.progress_indicator_type && options.progress_indicator_type=='bar'){
    	var $progressText = $('<div class="swfpr"></div>').html('<div class="progressContainer"><div class="progressBar"></div></div>');
	    $progressText.find('.progressBar').css({width:'0%'});
	    
	    $item.append($progressText).append($progressCancel);
    } else {
	    var $progressText = $('<div></div>').attr({'class' : 'progressText'});
	    $progressText.text('0%');
	    
	    var $progressIndicator = $('<div></div>').attr({'class': 'progressIndicator'});
	    
	    $item.append($progressIndicator).append($progressText).append($progressCancel);
    	$progressIndicator.spin(options.spin ? options.spin : {radius:20});
    }

    $progressCancel.find('a').on('click', function(){
        uploader.removeFile(file_id);
		uploader.trigger('StateChanged');
		uploader.trigger('CancelUpload');
        swfuCancelUpload(uniq_id);
        
        return false;
    });

    $item.css({display:'none'}).appendTo($upload).fadeIn('fast');
}

var swfuGetExtArr=function(){
	return {
		image:[['gif', 'jpg', 'jpeg', 'png', 'bmp', 'tiff', 'tif'], 'Image Files'],
		audio:[['mp3', 'wav'], 'Audio Files'],
		video:[['mp4', 'flv', 'avi', 'wmv', 'asf', 'mpg', 'mpeg', 'mov'], 'Video Files'],
		doc:[['doc', 'docx', 'rtf', 'txt', 'pdf', 'html', 'xls', 'xlsx', 'csv', 'ppt', 'pptx'], 'Doc Files'],
		flash:[['swf'], 'Adobe Flash Files'],
		script:[['php', 'js', 'c', 'cpp'], 'Script Files'],
		other:[['rar', 'zip', 'tar', 'gz', 'tgz', '7z','csv', 'log','psd', 'eps', 'ico', 'mmap', 'xmind', 'vsd'], 'Other'],
		csv:[['csv'], 'CSV']
	};
}

var swfuFtype2Mimes=function(ftypes){
	var ext_arr=swfuGetExtArr();
	
	ext_arr['all']=[[], 'All Files'];
	$.each(ext_arr, function(ext_type, ext_item){
		if(ext_type=='all') return;
		
		for(var i=0; i<ext_item[0].length; i++){
			if(!array_has(ext_arr['all'][0], ext_item[0][i])) ext_arr['all'][0].push(ext_item[0][i]);
		}
	})
	
	var mimes=[];
	ftypes=ftypes.split(',');
	$.each(ftypes, function(i, ftype){
		ftype=ftype.trim();
		if(ext_arr[ftype]){
			mimes.push({title:ext_arr[ftype][1], extensions:ext_arr[ftype][0].join(',')});
		}
	})

	return mimes;
}

var swfuExt2Ftype=function(ext){
	var ext_arr=swfuGetExtArr();
	var res_type='other';
	
	$.each(ext_arr, function(ext_type, ext_item){
		if(array_has(ext_item[0], ext)){
			res_type=ext_type;
			return false;
		}
	})
	
	if (res_type=='image' || array_has(['psd', 'eps'], ext)) res_type='image';
	else if (res_type=='video') res_type='video';
	else if (array_has(['mmap', 'xmind', 'vsd'], ext)) res_type='other_mmap';
	else if (array_has(['csv', 'xls', 'xlsx'], ext)) res_type='doc_excel';
	else if (array_has(['ppt', 'pptx'], ext)) res_type='doc_ppt';
	else if (array_has(['pdf'], ext)) res_type='doc_pdf';
	else if (array_has(['zip', 'rar', 'tar', 'gz', 'tgz', '7z'], ext)) res_type='arc';
	
	return res_type;
}

function getReadableFileSizeString(fileSizeInBytes) {
    var i = -1;
    var byteUnits = [' kB', ' MB', ' GB', ' TB', 'PB', 'EB', 'ZB', 'YB'];
    do {
        fileSizeInBytes = fileSizeInBytes / 1024;
        i++;
    } while (fileSizeInBytes > 1024);

    return Math.max(fileSizeInBytes, 0.1).toFixed(1) + byteUnits[i];
};

initSChk=function($schk){
	if ($schk.hasClass('schk_inited')){
		return false;
	}
	$schk.addClass('schk_inited');
	$schk.click(function(e){
		if(e.target.type=='checkbox'){
	        if ($(this).hasClass('disabled')){
	            return false;
	        }
	        
			var input=$schk.find('input').get(0);
			var $node=$(this).find('.schki');
	
			$node.toggleClass('schki_check');
		}
	})
}